//入力
//======================================================================================

Game.prototype.SHOOT = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.J] || bbw[keys.Ctrl] || bbw[keys.L]  || bbw[keys.PadA]  || bbw[keys.PadX]);
}
Game.prototype.SHOOTSUB = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.I] || bbw[keys.Space] || bbw[keys.Shift]  || bbw[keys.PadB] );
}
Game.prototype.BOMB = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.K] || bbw[keys.Alt] || bbw[keys.PadY] );
}
Game.prototype.UP = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.W] || bbw[keys.Up] || bbw[keys.PadUp] || bbw[keys.APadUp]);
}
Game.prototype.DOWN = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.S] || bbw[keys.Dw] || bbw[keys.PadDw] || bbw[keys.APadDw]);
}
Game.prototype.LEFT = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.A] || bbw[keys.Le] || bbw[keys.PadLe] || bbw[keys.APadLe]);
}
Game.prototype.RIGHT = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.D] || bbw[keys.Ri] || bbw[keys.PadRi] || bbw[keys.APadRi]);
}

//キーボードプッシュ
document.addEventListener("keydown", keyDownFunc);
function keyDownFunc(e) {
		keyPulls[e.keyCode] = true;
		keyPushs[e.keyCode] = true;
}

//キーボードリリース
document.addEventListener("keyup", keyUpFunc);
function keyUpFunc(e) {
	keyPulls[e.keyCode] = false;
}


//ゲームパッド
function GamePadFunc(){
	var gamepadList = navigator.getGamepads();
	for(var i=0; i<gamepadList.length; i++){
		var gamepad = gamepadList[i];
		if (gamepad) {
			document.getElementById("Pad").textContent = gamepad.id;



			for(var i=0; i<gamepad.buttons.length; i++){
				if (!keyPulls[i+5000] && gamepad.buttons[i].pressed) keyPushs[i+5000] = gamepad.buttons[i].pressed;
				keyPulls[i+5000] = gamepad.buttons[i].pressed;
			}

			const h = 0.5;
			if (keyPulls[keys.APadRi] && gamepad.axes[0] > h)	keyPushs[keys.APadRi] = true;
			if (keyPulls[keys.APadLe] && gamepad.axes[0] < -h)	keyPushs[keys.APadLe] = true;
			if (keyPulls[keys.APadDw] && gamepad.axes[1] > h)	keyPushs[keys.APadDw] = true;
			if (keyPulls[keys.APadUp] && gamepad.axes[1] < -h)	keyPushs[keys.APadUp] = true;

			keyPulls[keys.APadRi] = (gamepad.axes[0] > h);
			keyPulls[keys.APadLe] = (gamepad.axes[0] < -h);
			keyPulls[keys.APadDw] = (gamepad.axes[1] > h);
			keyPulls[keys.APadUp] = (gamepad.axes[1] < -h);

		}
	}
}

//======================================================================================
//======================================================================================
//======================================================================================