//通常敵プッシュ
Game.prototype.SpritePush = function(x,y,hx,hy,data) {
	const i = game.NullFined(Sprites);
	Sprites[i]=data;
	//そして基本的情報を挿入
	game.SpriteKiso(Sprites[i],x,y,hx,hy,KeyIndexs);
	KeyIndexs++;
}
//敵の基本情報
Game.prototype.SpriteKiso = function(data,x,y,hx,hy,key) {
	data.Key = key;
	data.Live = true;				//生存確認
	data.x = x,	data.y = y;			//座標
	data.hx = hx,	data.hy = hy;	//慣性
	data.Debu = 0;					//脂肪
	data.Fat = 0;					//デブ度の段階
	data.Dame = false;				//フレームのダメージ
	data.DameTimer = 0;				//ダメージを受けてからの経過時間
	data.Timer = 0;					//タイマー
	data.DrawSize = 0;
	data.PoyoTimer = 0;

	data.Kutix = 0;					//口の相対座標
	data.Kutiy = 0;
}

	const helthkake = 0.6;		//ボスのHPにかけるやつ

//テストスプライト
//==============================================================================================
Game.prototype.TestMan = function() {
	this.Size = [30,30];
}
Game.prototype.TestMan.prototype.Func = function(index) {
	//描画
	game.DrawKage(ctxA,GFXs["Test"],this.x,this.y,this.DrawSize,this.DrawSize,game.Dame(this.Dame),false,false);

	game.GamenOut(this);	//画面外消失

	if (this.Dame != false) {
		if (this.Debu > 100) {
			this.Live = false;
			//game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		} else {
		}
	}
			this.x -= 1;
}

//バイオコーン
//==============================================================================================
Game.prototype.Toumorokosi = function(s) {
	this.Roll = Math.random()*PI,	this.RollPls = (Math.random()-0.5)/12;
	this.S = s;
	this.Size = [60*s,60*s];
}
Game.prototype.Toumorokosi.prototype.Func = function(index) {

	if (game.PlayerHit(this)) {
		const r = game.PlayerRadis(this.x,this.y);
		this.hx = r[0]*-10;
		this.hy = r[1]*-10;
		//this.Dame = true;
		//this.Debu += 1;
	}
	game.Move(this);		//慣性移動
	game.MoveLose(this,0.95);	//摩擦
	game.GamenOut(this);	//画面外消失

	this.x -= 8*(2-this.S);
	this.Roll += this.RollPls;

	//描画
	game.DrawKage(ctxA,GFXs["Tama14"],	this.x,this.y,	this.S,this.S,	game.Dame2(this.Dame),this.Roll		,false);

	if (this.Dame != false) {
		if (this.Debu > 20) {
			this.Live = false;
			game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
			for (let i=0 ; i<16 ; i++) {
				let s = Math.random()*2 + 5;
				let r = Math.random()*TwoPI;
				game.SFXPush(this.x, this.y,	Math.cos(r)*s, Math.sin(r)*s,	false,	new game.Himatu("Sfx60"));
				//game.SFXPush(this.x, this.y,	game.Random(8),game.Random(8)-5,	false,	new game.Himatu("Sfx60"));
			}
			game.ScoreMan(30);		//スコア
			game.PlaySE("Boom00");		//音
		} else {
			game.SFXPush(this.x, this.y,	game.Random(10)+5,game.Random(10)-10,	false,	new game.Himatu("Sfx60"));
			this.hx = 2;
			this.RollPls = this.RollPls*1.2;
		}
	}

}

/*
コピペ用
//==============================================================================================
	game.Move(this);		//慣性移動
	game.GamenOut(this);	//画面外消失
	//描画
	game.DrawKage(ctxA,GFXs["Test"],	this.x,this.y,	this.DrawSize,this.DrawSize,		game.Dame(this.Dame),false,	false);
*/

//ねずみさん
//==============================================================================================
Game.prototype.Nezumi = function(a, gx, gy) {
	this.Size = [40,100];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Nezumi.prototype.Func = function(index) {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 330) {
		this.Live = false;

		//game.SFXPush("Ban",this.x, this.y, 0,0, 0,0, null);

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//game.FuncBoom1(this.x,this.y);	//爆破
		//game.NikuFunc(this.x, this.y, 3);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			//this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>8) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki00"];


		//健康的
		if (this.Debu < 10) {

			this.Size = [40,100];
			game.FatSE(this, 0, 0);	//デブ音
			game.Okuti(this,-30,-50); //口の座標セット

			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer++;
				if (this.AttackTimer<150) {
					img = GFXs["Teki01"];
					game.Okuti(this,-10,-45); //口の座標セット

					//発射
					if (game.LiveShoot() && (this.AttackTimer == 50 || this.AttackTimer == 80 || this.AttackTimer == 110)) {
						this.DrawSize -= 0.2;
						const r = game.PlayerRadis(this.x,this.y + game.Random(200)*(1-Rank));
						game.TekiTamaPush(this.x-50, this.y,	r[0]*7*Rank,r[1]*7*Rank, r[2],		new game.TizuShoot());
						this.hx -= r[0]*3;
						this.hy -= r[1]*3;
						game.PlaySE("Shoot01");		//音
					}
				}
			}
		//肥満気味
		} else {

			this.AttackTimer = 0;

			if (this.Debu<100) {
				img = GFXs["Teki02"];
				this.Size = [50,100];
				game.FatSE(this, 1, 0);	//デブ音
				game.Okuti(this,0,-55); //口の座標セット

			} else if (this.Debu<200) {
				img = GFXs["Teki03"];
				this.Size = [80,100];
				game.FatSE(this, 2, 0);	//デブ音
				game.Okuti(this,-20,-70); //口の座標セット

			} else {
				game.AseFunc(this.x+60, this.y-100);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				//game.ScoreMan(1);		//スコア
				img = GFXs["Teki04"];
				this.Size = [100,100];
				game.FatSE(this, 3, 0);	//デブ音
				game.Okuti(this,5,-90); //口の座標セット

			}

		}

		//行動
		switch (this.Action) {
			//右へ帰る
			case 1:
			case 2:
				const tt = this.Action==1 ? 600 : 800;
				if (t<tt) {
					if ( t==50 || t==300 || t==600) this.AttackTimer = 1;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gx += (t-tt)/2;
				}
				this.hx += Math.cos(t/32+index)*0.08;
				this.hy += Math.cos(t/16+index)*0.08;
				this.x = (this.x*99 + this.gx)/100;
				this.y = (this.y*99 + this.gy)/100;
				break;

			//左へ
			case 5:
				if (t<300) {
					if ( t==10 || t==110) this.AttackTimer = 1;
					if (this.Debu<10) this.gx -= 3;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gx += 10;
				}
				game.GoMove2(this, this.gx, this.gy, 0.03);		//座標指定
				this.hy += Math.cos(t/12)*0.1;
				break;
		}


		game.Move(this);				//慣性移動
		game.MoveLose(this,0.98);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,330,0.3),this.DrawSize, game.Dame(this.Dame),false,	false);
	}

}

//うさぎさん
//==============================================================================================
Game.prototype.Usagi = function(a,gx,gy) {
	this.Size = [40,100];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Usagi.prototype.Func = function(index) {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 330) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.SFXPush("Ban",this.x, this.y, 0,0, 0,0, null);

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//game.NikuFunc(this.x, this.y, 3);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki20"];

		//健康的
		if (this.Debu < 10) {

			this.Size = [40,100];
			game.FatSE(this, 0, 0);	//デブ音
			game.Okuti(this,-30,-30); //口の座標セット

			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer++;
				if (this.AttackTimer<150) {
					img = GFXs["Teki21"];
					game.Okuti(this,20,-40); //口の座標セット
					//発射
					if (game.LiveShoot() && (this.AttackTimer == 50 || this.AttackTimer == 70 || this.AttackTimer == 90)) {
						this.DrawSize -= 0.2;
						game.TekiTamaPush(this.x-50, this.y,	-10*Rank,0, PI,		new game.NInzinShoot());
						game.PlaySE("Shoot01");		//音
					}
				}
			}

		//肥満気味
		} else {
			this.AttackTimer = 0;

			if (this.Debu<100) {
				img = GFXs["Teki22"];
				this.Size = [50,100];
				game.FatSE(this, 1, 0);	//デブ音
				game.Okuti(this,-25,-30); //口の座標セット

			} else if (this.Debu<200) {
				img = GFXs["Teki23"];
				this.Size = [60,100];
				game.FatSE(this, 2, 0);	//デブ音
				game.Okuti(this,-25,-50); //口の座標セット

			} else {
				game.AseFunc(this.x+60, this.y-100);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				//game.ScoreMan(1);		//スコア
				img = GFXs["Teki24"];
				this.Size = [80,120];
				game.FatSE(this, 3, 0);	//デブ音
				game.Okuti(this,-20,-70); //口の座標セット

			}
		}

		//行動
		switch (this.Action) {
			//右へ帰る
			case 1:
			case 2:
				const tt = this.Action==1 ? 600 : 800;
				if (t<tt) {
					if (t%200==0) this.AttackTimer = 1;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gx += (t-tt)/2;
				}
				//this.hx += Math.cos(t/32)*0.08;
				this.x = (this.x*99 + this.gx)/100;
				this.y = (this.y*99 + this.gy)/100;
				break;
		}


		game.Move(this);			//慣性移動
		game.MoveLose(this,0.98);		//摩擦


		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,330,0.3),this.DrawSize,	game.Dame(this.Dame),false,	false);
	}

}

//はちさん
//==============================================================================================
Game.prototype.Hati = function(a, gx=0, gy=0) {
	this.Size = [40,70];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Hati.prototype.Func = function(index) {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;
	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし
	//しぼう
	if (this.Debu > 90) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,10);
		game.ScoreMan(50);		//スコア
		game.PlaySE("Boom00");		//音

		game.NikuFunc(this.x, this.y, 3);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki10"];

		//健康的
		if (this.Debu == 0) {
				img = Loop4 ? GFXs["Teki10"] : GFXs["Teki11"];
				this.Size = [40,70];
				game.Okuti(this,-5,0); //口の座標セット

				//発射
				if (t%10==0 && t%50<30) {
					this.DrawSize -= 0.1;
					game.TekiTamaPush(this.x-50, this.y+10,	-15*Rank,0, PI,		new game.HariShoot());
				}
				game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			//game.ScoreMan(1);		//スコア
			//game.NikusFunc(this.x, this.y);	//肉ばら撒き
			this.Size = [60,70];
			this.hx *= 0.99;
			img = GFXs["Teki12"];
			game.AseFunc(this.x+60, this.y-100);
			game.FatSE(this, 1, 0);	//デブ音
			game.Okuti(this,0,-50); //口の座標セット
		}

		//行動
		switch (this.Action) {
			//
			case 0:
				if (t>300) {
					game.GamenOut(this);	//画面外消失
				}
				this.hx = Math.max(-3, this.hx-0.05);
				break;

			case 5:
				if (t>300) game.GamenOut(this);	//画面外消失
				game.GoMove2(this, this.gx, this.gy, 0.03);		//座標指定
				if (this.Debu<10) this.gx -= 3;
				break;

		}

		this.hy += Math.cos(t/12)*0.1;


		game.Move(this);		//慣性移動


		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,90,0.3),this.DrawSize,	game.Dame(this.Dame),false,	false);
	}

}

//キツネさん
//==============================================================================================
Game.prototype.Kitune = function(a, gx, gy) {
	this.Size = [40,120];
	this.Action = a;
	this.AttackTimer = 0;
	this.ShootR = 0;

	this.ShootX = 0;	this.ShootY = 0;

	this.gx = gx,	this.gy = gy;
}
Game.prototype.Kitune.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 600) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//game.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki30"];
		let plssize = 0;

		//健康的
		if (this.Debu < 150) {
			this.Size = [40,120];
			game.Okuti(this,-10,-70); //口の座標セット

			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {

				img = GFXs["Teki31"];
				game.Okuti(this,10,-60); //口の座標セット

				//発射
				if (this.AttackTimer == 80) {
					this.ShootR = game.PlayerRadi(this.x,this.y);
				}

				if (game.LiveShoot() && this.AttackTimer%10==0 && this.AttackTimer<80 && this.AttackTimer>30+30*(2-Rank)) {

					const radi = this.ShootR;
					//const radi = game.Radi(this.x,this.y,this.ShootX,this.ShootY);
					let speed = 5;

					let rr = 0.7 - Rank*0.2;
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi+rr)*speed,Math.sin(radi+rr)*speed, radi+rr,		new game.OinariShoot());
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi-rr)*speed,Math.sin(radi-rr)*speed, radi-rr,		new game.OinariShoot());
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,			new game.OinariShoot());
					rr *= 2;
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi+rr)*speed,Math.sin(radi+rr)*speed, radi+rr,		new game.OinariShoot());
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi-rr)*speed,Math.sin(radi-rr)*speed, radi-rr,		new game.OinariShoot());

					this.hx -= Math.cos(radi)*1;
					this.hy -= Math.sin(radi)*1;

					this.DrawSize -= 0.2;
					game.PlaySE("Shoot01");		//音
				}
				this.AttackTimer--;
			}
			game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			this.AttackTimer = 0;

			if (this.Debu<250) {
				img = GFXs["Teki32"];
				this.Size = [60,120];
				game.FatSE(this, 1, 0);	//デブ音
				game.Okuti(this,5,-85); //口の座標セット

			} else if (this.Debu<400) {
				img = GFXs["Teki33"];
				this.Size = [90,130];
				game.FatSE(this, 2, 0);	//デブ音
				game.Okuti(this,-35,-90); //口の座標セット

			} else {
				game.AseFunc(this.x+60, this.y-130);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki34"];
				this.Size = [110,140];
				game.FatSE(this, 3, 0);	//デブ音
				game.Okuti(this,-25,-130); //口の座標セット

			}

		}

		//行動
		switch (this.Action) {

			case 1:	//上へ帰る
			case 2:	//下へ帰る

				if (t<400) {
					if (this.Debu<1 && this.AttackTimer==0) {
						if ((t>50 && t<150) || (t>300 && t<400))  {
							this.AttackTimer = 100;
						}
					}
					this.gy += (this.Action==1 ? -1 : 1)*1;

					this.hx += Math.cos(t/32)*0.08;
					this.hy += Math.cos(t/16)*0.08;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gy += (this.Action==1 ? -3 : 3);
				}
				break;
		}

		//this.hx += Math.cos(t/32)*0.08;
		//this.hy += Math.cos(t/16)*0.08;
		this.x = ((this.x - this.gx) * 0.95) + this.gx;
		this.y = ((this.y - this.gy) * 0.95) + this.gy;

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.98);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize+plssize + game.PuyoMan(this,600,0.2),this.DrawSize+plssize,	game.Dame(this.Dame),false,	false);
	}

}

//ラムさん
//==============================================================================================
Game.prototype.Ramu = function(a, gx, gy) {
	this.Size = [40,120];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
	this.ShootRadi = 0;
}
Game.prototype.Ramu.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 700) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki40"];
		let plssize = 0;

		//健康的
		if (this.Debu < 150) {
			this.Size = [40,140];
			game.Okuti(this,-10,-85); //口の座標セット

		/*if (game.LiveShoot() && Rank>1.5) {
			if(this.Timer<80 && this.Timer%15==0) {
				const radi = game.PlayerRadi(this.x,this.y);
				const speed = 10 * Rank;
				game.TekiTamaPush(this.x,this.y,Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.FuramsuShoot());
				this.DrawSize -= 0.1;
				game.PlaySE("Shoot01");		//音
			}
		}*/

			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer--;
				img = GFXs["Teki41"];
				game.Okuti(this,-5,-85); //口の座標セット



				/*if (this.AttackTimer==140) this.ShootRadi = game.PlayerRadi(this.x,this.y);
				//発射
				if (game.LiveShoot() && (this.AttackTimer > 20 && this.AttackTimer < 80+60*Rank && this.AttackTimer%20 == 0)) {
					this.DrawSize -= 0.2;
					const radi = this.ShootRadi;
					let speed = 5 * Rank+2;
					//const rr = (Math.cos(t/8)/50+ 0.03) * Rank;
					const rr = 0.03 * Rank;

					if (this.AttackTimer%40 < 10) {
						game.TekiTamaPush(this.x + Math.cos(radi+HalfPI)*20,this.y + Math.sin(radi+HalfPI)*20,
							Math.cos(radi+rr)*speed,Math.sin(radi+rr)*speed, radi+rr,		new game.FuramsuShoot());
					} else {
						game.TekiTamaPush(this.x + Math.cos(radi-HalfPI)*20,this.y + Math.sin(radi-HalfPI)*20,
							Math.cos(radi-rr)*speed,Math.sin(radi-rr)*speed, radi-rr,		new game.FuramsuShoot());
					}
					this.hx -= Math.cos(radi)*4;
					this.hy -= Math.sin(radi)*4;
					game.PlaySE("Shoot01");		//音
				}*/

				if (game.LiveShoot() && ((this.AttackTimer == 120) || (this.AttackTimer == 100 && Rank>1.5) || (this.AttackTimer == 80 && Rank>1.8))) {

					const radi = game.PlayerRadi(this.x,this.y);

					const rr = 0.04 * Rank;

					for (let i=2 ; i>=-2 ; i--) {
						const speed = 5 * Rank+2 - Math.abs(i*0.1);
						game.TekiTamaPush(this.x + Math.cos(radi+HalfPI)*20,this.y + Math.sin(radi+HalfPI)*20,
							Math.cos(radi+rr*i)*speed,Math.sin(radi+rr*i)*speed, radi+rr*i,		new game.FuramsuShoot());
					}
					this.hx -= Math.cos(radi)*4;
					this.hy -= Math.sin(radi)*4;

					this.DrawSize -= 0.2;
					game.PlaySE("Shoot01");		//音
				}

			}
			game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			this.AttackTimer = 0;
			if (this.Debu<300) {
				img = GFXs["Teki42"];
				this.Size = [60,150];
				game.FatSE(this, 1, 0);	//デブ音
				game.Okuti(this,-10,-90); //口の座標セット

			} else if (this.Debu<450) {
				img = GFXs["Teki43"];
				this.Size = [90,160];
				game.FatSE(this, 2, 0);	//デブ音
				game.Okuti(this,-10,-120); //口の座標セット

			} else {
				game.AseFunc(this.x+90, this.y-130);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki44"];
				this.Size = [110,170];
				game.FatSE(this, 3, 0);	//デブ音
				game.Okuti(this,50,-130); //口の座標セット

			}

		}

		//行動
		switch (this.Action) {

			case 1:	//上へ帰る
			case 2:	//下へ帰る

				if (t<400) {
					if (this.Debu<1 && this.AttackTimer==0) {
						if ((t>30 && t<150) || (t>300 && t<400))  {
							this.AttackTimer = 150;
							//this.ShootRadi = game.PlayerRadi(this.x,this.y);
						}
					}
					this.gx -= 1;

					//this.hx += Math.cos(t/32)*0.08;
					this.hy += Math.cos(t/16)*0.1;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gy += (this.x < 0 ? -3 : 3);
				}
				break;
		}

		//this.hx += Math.cos(t/32)*0.08;
		//this.hy += Math.cos(t/16)*0.08;
		this.x = ((this.x - this.gx) * 0.97) + this.gx;
		this.y = ((this.y - this.gy) * 0.97) + this.gy;

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize+plssize + game.PuyoMan(this,700,0.2),this.DrawSize+plssize,	game.Dame(this.Dame),false,	false);
	}

}

//リスさん
//==============================================================================================
Game.prototype.Risu = function(a) {
	this.Size = [40,70];
	this.Action = a;
	this.AttackTimer = 0;
}
Game.prototype.Risu.prototype.Func = function() {
	const t = this.Timer;
	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 50) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,10);
		game.ScoreMan(50);		//スコア
		game.PlaySE("Boom00");		//音

		//打ち返し
		const radi = game.PlayerRadi(this.x,this.y);
		if(Rank<1.5) {
			game.TekiTamaPush(this.x,this.y,	Math.cos(radi),Math.sin(radi),	radi,		new game.NattuShoot());
		} else {
			const pls = 0.03;
			game.TekiTamaPush(this.x,this.y,	Math.cos(radi+pls),Math.sin(radi+pls),	radi+pls,		new game.NattuShoot());
			game.TekiTamaPush(this.x,this.y,	Math.cos(radi-pls),Math.sin(radi-pls),	radi-pls,		new game.NattuShoot());
		}
		//game.PlaySE("Shoot01");		//音

		game.NikuFunc(this.x, this.y, 2);	//ニク撒き

	//生存中
	} else {

		let img = GFXs["Teki50"];

		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>60) this.Debu = Math.max(0,this.Debu-=1);
		}

		//健康的
		if (this.Debu == 0) {
				this.Size = [40,70];
				game.FatSE(this, 0, 0);	//デブ音
				game.Okuti(this,-20,-25); //口の座標セット

		//肥満気味
		} else {
			//game.ScoreMan(1);		//スコア
			//game.NikusFunc(this.x, this.y);	//肉ばら撒き
			this.Size = [60,70];

			this.hx *= 0.99;
			img = GFXs["Teki51"];
			game.AseFunc(this.x+60, this.y-100);
			game.FatSE(this, 1, 0);	//デブ音
			game.Okuti(this,-15,-75); //口の座標セット
		}

		//行動
		switch (this.Action) {
			//自機の方へ向かって右へ帰る
			case 0:
				if (t==1) this.hy = (Player.y - this.y)/100;
				if (t>150) {
					game.GamenOut(this);	//画面外消失
					this.hx += 0.2;
				}
				break;

			//右へ帰る
			case 1:
				if (t>150) {
					game.GamenOut(this);	//画面外消失
					this.hx += 0.2;
				}
				break;
		}

		this.hy += Math.cos(t/12)*0.1;


		game.Move(this);				//慣性移動
		game.MoveLose(this,0.99);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,50,0.2),this.DrawSize,	game.Dame(this.Dame),false,	false);
	}

}

//ぶたさん
//==============================================================================================
Game.prototype.Buta = function(a, gx, gy) {
	this.Size = [40,120];
	this.Action = a;
	this.AttackTimer = 0;
	this.AnimeR = 0;
	this.ShootR = Math.random()+TwoPI;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Buta.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 450) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(200);		//スコア
		game.PlaySE("Boom00");		//音

		//.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki60"];

		this.AttackTimer++;
		this.AnimeR *= 0.9;

		//健康的
		if (this.Debu < 100) {
			this.Size = [40,120];
			game.FatSE(this, 0, 0);	//デブ音
			game.Okuti(this,-35,-60); //口の座標セット

			const at = this.AttackTimer%100;

			if (game.LiveShoot() && at == 80) {
				this.DrawSize -= 0.2;

					/*for (let i=0 ; i<4 ; i++) {
						for (let j=0 ; j<3 ; j++) {
							const speed = 6*Rank - j;
							const radi = this.ShootR + i*HalfPI;
							game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
								Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.TizuShoot());

						}
					}
					this.ShootR += 0.2;*/
					

				/*const rad = PI-0.3;
				for (let i=0 ; i<4*Rank ; i++) {
					const speed = 6*Rank - i*0.5;
					let radi = rad;
					game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
						Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.HamuShoot());

					radi = TwoPI-rad;
					game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
						Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.HamuShoot());

				}*/

				for (let i=2+4*Rank ; i>0 ; i--) {
					const radi = game.PlayerRadi(this.x,this.y);// + (Math.random()-0.5);
					const speed = 15 - i;
					game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
						Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.HamuShoot());
				}

				game.PlaySE("Shoot01");		//音
				this.AnimeR = PI;
				this.hx += 12;
			}
			if (at>50) {
				img = GFXs["Teki64"];
				game.Okuti(this,Math.cos(this.AnimeR-1.1)*40,Math.sin(this.AnimeR-1.1)*40); //口の座標セット
			}

		//肥満気味
		} else {

			this.AttackTimer = 0;
			this.AnimeR = 0;

			if (this.Debu<200) {
				img = GFXs["Teki61"];
				this.Size = [60,150];
				game.FatSE(this, 1, 0);	//デブ音
				game.Okuti(this,-10,-95); //口の座標セット

			} else if (this.Debu<300) {
				img = GFXs["Teki62"];
				this.Size = [90,160];
				game.FatSE(this, 2, 0);	//デブ音
				game.Okuti(this,-25,-110); //口の座標セット

			} else {
				game.AseFunc(this.x+90, this.y-160);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki63"];
				this.Size = [110,170];
				game.FatSE(this, 3, 0);	//デブ音
				game.Okuti(this,15,-180); //口の座標セット
			}

		}

		//行動
		switch (this.Action) {

			case 1:	//左へ
			case 2:	//左へ

					this.y += Math.sin(t/12);

					if (this.Timer > (this.Action==1 ? 500:700)) {
						this.gx += 6;
						game.GamenOut(this);	//画面外消失
					} else {
						if (this.Debu<300) this.gx -= 1;
					}
				break;
		}

		game.GoMove2(this, this.gx, this.gy, 0.01);		//座標指定
		game.Move(this);				//慣性移動
		game.MoveLose(this,0.95);		//摩擦

		this.AnimeTimer--;

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,450,0.2),this.DrawSize,	game.Dame(this.Dame),this.AnimeR,	false);
	}

}
//脂肪
//==============================================================================================
Game.prototype.SibouBall = function(s) {
	this.R = Math.random()*TwoPI;
	this.Size = [50,50];
	this.DSize = 1;
	this.Sedai = s;
}
Game.prototype.SibouBall.prototype.Func = function(index) {
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	//しぼう
	} else 	if (this.Debu > 8) {
		this.Live = false;

		//game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		//game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,6);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		game.NikuFunc(this.x, this.y, 1);	//ニク撒き

	//生存中
	} else {
		//if (game.PlayerHit(this)) {
		if (Loop%5 == index%5) {
			const ataris = game.Ataris2(this);
			for (let i=0 ; i<ataris.length-1 ; i++) {
				const r = game.Radi(this.x,this.y,	Sprites[ataris[i]].x,Sprites[ataris[i]].y);
				const f = 1;
				this.x += Math.cos(r)*-f;
				this.y += Math.sin(r)*-f;
				Sprites[ataris[i]].x += Math.cos(r)*f;
				Sprites[ataris[i]].y += Math.sin(r)*f;

				this.hx += Math.cos(r)*-2;
				this.hy += Math.sin(r)*-2;
			}
		}
		this.y = Math.min(HeightHalf, Math.max(-HeightHalf,this.y));
		this.x -= 2;

		game.Move(this);				//慣性移動
		game.MoveLose(this,0.7);		//摩擦
		//game.GamenOut(this);	//画面外消失

		if (this.x<-WidthHalf-100) {
			this.Live = false;
		}

		//this.Size[0] = this.Sizer;
		//this.Size[0] = this.Sizer;

		if(this.Timer>(100-(Rank-1)*50) && this.x<WidthHalf) {
			if (this.Sedai > 0) {
				this.Sedai--;
				this.DSize = 1;
				for (let j=0 ; j<2 ; j++) {
					game.SpritePush(this.x+Math.random()-0.5, this.y+Math.random()-0.5, 0,0,	new game.SibouBall(this.Sedai));
				}
				this.Timer = 0;
				game.PlaySE("FatA01");		//音
				//this.Live = false;
			}
		}
		this.DSize = Math.min(2, this.DSize + 0.01);


		const size = this.DSize + Math.sin(this.Timer/3+index)/7;
		const ss = size + game.PuyoMan(this,10,0.3);
		game.Draw(ctxA,GFXs["Tama33"],	this.x,this.y,	ss,ss,	game.Dame(this.Dame),this.R,	false);
		game.Draw(ctxB,GFXs["Tama24"],	this.x, this.y,	size,size,	false,Math.random(),	["add"]);
	}

}

//キノダガード
//==============================================================================================
Game.prototype.Guard = function() {
	this.Size = false;
	this.ShootR = 0;

	this.MaeX = 0;
	this.JetSe = game.PlaySE("Jet00",1,1,1,true);
}
Game.prototype.Guard.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	//ジェット音
	//if(this.Timer==0) this.JetSe = game.PlaySE("Jet00",1,1,1,true);		//音
	game.ChangeParamSE(this.JetSe,1,	Math.max(0.5,Math.min(2,1 + Math.abs(this.x - this.MaeX)*0.02))	,1.5,false);
	this.MaeX = this.x;


	//しぼう
	if (this.Debu > 800) {
		this.Live = false;


		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom02");		//音

		game.FuncBoom1(this.x,this.y);	//爆破

		game.NikuFunc(this.x, this.y, 6);	//ニク撒き
		game.SFXPush(this.x+100, this.y, 0,-10, 0,	new game.FatGuard());	//落ちる君

		game.ChangeParamSE(this.JetSe,0,1,1,false);

		game.TekiTamaNikuing();		//弾消し

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			//this.DrawSize -= 0.1;
			//this.PoyoTimer = 1;
		} else {
			//if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}


		game.Move(this);				//慣性移動
		//通過
		if (t<80) {
				this.hx = 30;
				game.DrawKage(ctxB,GFXs["Teki71"],	this.x, this.y,	1,1,	false,false,	false);

		} else {
			game.PlayerBuyon(this,false);		//プレーヤー突き飛ばし

			game.MoveLose(this,0.99);		//摩擦

			let drawr = 1 + this.hx/30;

			game.DrawKage(ctxB,GFXs["Teki70"],	this.x, this.y + Math.cos(t*2)*2,	1,1,	this.Dame ? "rgba(255,255,255,0.8)" : false,drawr,				false);
			game.DrawKage(ctxA,GFXs["Teki72"],	this.x+50, this.y-50 - this.hx*2,	1,1,	false,false,	false);
			this.Size = [100,200];

			game.Okuti(this,Math.cos(drawr+3.3)*120,Math.sin(drawr+3.3)*120); //口の座標セット

			//移動パターン
			/*if (t==100) {
				//this.x = 800;
				//this.MaeX = this.x;
				//this.hx = -10;
			}*/

			if (t<115) {
				this.hx -= 2;

			} else if (t<400) {
				if (t<170) game.MoveLose(this,0.95);
				this.hx += this.x>Math.min(500,Player.x+800) ? -0.3 : 0.3;
				//game.MoveLose(this,0.99);
			} else {
				this.hx += 0.8;
				//game.GamenOut(this);	//画面外消失

				if(t>450) {
					this.Live = false;
					game.ChangeParamSE(this.JetSe,0,1,1,false);
				}
			}

			//攻撃
 			//if (t==400) this.ShootR = game.PlayerRadi(this.x-50,this.y-80);
			if (game.LiveShoot() && t<350) {
				if (t>200 && (t%Math.ceil(3+4*(2-Rank))==0) ) {

				game.Draw(ctxA,GFXs["Sfx24"],
					this.x-50,this.y-80, 1,1,	false,Math.random(),	false);

					const speed = 15*Rank;
					//const radi = -PI + (Math.random()-0.5)*0.1*Rank;
					const radi = -PI + (Math.random()-0.5)*2.5;
					game.TekiTamaPush(this.x-50,this.y-80,Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.MateShoot());

					game.PlaySE("Shoot01");		//音
				}
			}


			if (this.Debu > 300) game.FuncHeatSmoke1(this.x-50, this.y-100,	10,-10);
			//if (this.Debu > 750) game.FuncHeatSmoke1(this.x, this.y,	Math.cos(t/8)*20,Math.sin(t/8)*20);
			//if (this.Debu > 750 && Loop3) 		game.SFXPush(this.x, this.y, game.Random(30),game.Random(30), 0,	new game.HeatBeen());

			this.hy += Math.sin(t/12)/10;

		}


	}

}

//ラッコさん
//==============================================================================================
Game.prototype.Rakko = function(r=-PI,pr=0) {
	this.Size = [100,100];
	this.Radi = r;
	this.PlsRadi = pr
	this.Speed = 0;
}
Game.prototype.Rakko.prototype.Func = function(index) {
	//if(this.Timer==0) {
		this.hx = Math.cos(this.Radi);
		this.hy = Math.sin(this.Radi);
	//}


	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 250) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(300);		//スコア
		game.PlaySE("Boom00");		//音

		//.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki80"];
		let okutil = 80;	//口の距離


		//健康的
		if (this.Debu < 10) {
			game.FatSE(this, 0, 0);	//デブ音

			if (game.LiveShoot() && t>20) {
				if (t%Math.ceil(8+5*(2-Rank))==0 ) {

					const speed = 5;
					const radi = (this.Timer+index)/6;
					game.TekiTamaPush(this.x,this.y,Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.KaiShoot());

					//game.PlaySE("Shoot01");		//音
				}
			}


		//肥満気味
		} else {
			this.Speed *= 0.97;

			if (this.Debu<50) {
				img = GFXs["Teki81"];
				game.FatSE(this, 1, 0);	//デブ音
				let okutil = 100;	//口の距離

			} else if (this.Debu<150) {
				img = GFXs["Teki82"];
				game.FatSE(this, 2, 0);	//デブ音
				let okutil = 110;	//口の距離

			} else {
				game.AseFunc(this.x+90, this.y-160);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki83"];
				game.FatSE(this, 3, 0);	//デブ音
				let okutil = 170;	//口の距離
			}

		}

		game.Okuti(this, Math.cos(this.Radi)*okutil,Math.sin(this.Radi)*okutil); //口の座標セット

		//行動
		if(t>300 || this.Debu<10) {
			this.Speed += 0.1;
		} else {
		}


		if(t>200) {
			game.GamenOut(this);	//画面外消失
		}


		game.Move(this, this.Speed);				//慣性移動
		this.Speed *= 0.99;

		this.Radi += this.Speed * 0.0001 * this.PlsRadi;

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize,this.DrawSize + game.PuyoMan(this,250,0.2),	game.Dame(this.Dame),this.Radi,	false);
	}

}

//バロンさん
//==============================================================================================
Game.prototype.Baron = function() {
	this.Size = [60,260];
	this.Action = 0;
	this.AttackTimer = 0;
	this.ShootR = 0;
	this.NikuTimer = 0;
}
Game.prototype.Baron.prototype.Func = function(index) {
	//キホン
	const t = this.Timer;
	let img = "Test";

	game.PlayerBuyon(this,false);		//プレーヤー突き飛ばし

	//ダメージ
	if (this.Dame) {
		this.DrawSize -= 0.05;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=40) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
	} else {
		//this.Debu = Math.max(0,this.Debu-=2);
		//this.Debu += 1;
	}

	let ttt = t;
	switch (this.Action) {
		//初肉
		case 0:
			game.GoMove(this,		250, 0,		100);
			img = "Boss10";
			game.Okuti(this,-40,-160); //口の座標セット
			if (t==200) {
				this.Action = 10;
				this.Timer = 0;
				//this.Debu = 14000;
			}
			break;

		//痩せ
		case 10:
			game.GoMove(this,		300, Math.sin(t/90)*200,		100);
			img = "Boss10";
			game.Okuti(this,-40,-160); //口の座標セット

			ttt = t%250;
			if (ttt<200) {
				img = "Boss11";
				game.Okuti(this,10,-210); //口の座標セット

				if ((ttt == 50 || ttt == 100 || ttt == 150) && game.LiveShoot()) {
						this.DrawSize -= 0.1;
						this.hx += 3;
						game.TekiTamaPush(this.x-220, this.y,	4,13, PI,		new game.OnoShoot(1,1));
						game.TekiTamaPush(this.x-220, this.y,	2,9, PI,		new game.OnoShoot(1,1));

						game.TekiTamaPush(this.x-220, this.y,	4,-13, PI,		new game.OnoShoot(1,1));
						game.TekiTamaPush(this.x-220, this.y,	2,-9, PI,		new game.OnoShoot(1,1));
						game.PlaySE("Shoot03");		//音
				}
			}

			//移行
			if (this.Debu > 4000 * helthkake) {
				this.Action = 20;
				this.Timer = 300;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA00");		//デブ音
				game.FatSE(this, 1, 0);	//デブ音
			}
			break;

		//ぽちゃ
		case 20:

			game.GoMove(this,		350, Player.y,		100);
			img = "Boss17";
			game.Okuti(this,-60,-190); //口の座標セット
			ttt = t%400;
			if (ttt<200) {
				img = "Boss16";
				game.Okuti(this,-40,-170); //口の座標セット
				if (ttt>50 && ttt<150) {
					if (ttt%8==0 && ttt%50<25 && game.LiveShoot()) {
						this.DrawSize -= 0.1;
						this.hx += 0.1;
						game.TekiTamaPush(this.x-250, this.y,	5, 0, PI,		new game.OnoShoot(4,1));
						game.PlaySE("Shoot03");		//音
					}
				}
			} else {
				if (t>400 && ttt%30==0 && game.LiveShoot()) {
					this.DrawSize -= 0.05;
					const r = game.PlayerRadis(this.x-50, this.y-100);
					game.TekiTamaPush(this.x-50, this.y-100,	r[0]*10,r[1]*10, r[2],		new game.NikuShoot());
					game.PlaySE("Shoot02");		//音
				}
			}


			//移行
			if (this.Debu > 8000 * helthkake) {
				this.Action = 30;
				this.Timer = 450;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA01");		//デブ音
				game.FatSE(this, 2, 0);	//デブ音
			}
			break;

		//おでぶ
		case 30:
			this.Size = [80,260];
			img = t%80<40 ? "Boss12" : "Boss13";
			game.Okuti(this,-10,-200); //口の座標セット
			ttt = t%500;
			//アックス
			if (ttt<350) {
				img = "Boss14";
				game.Okuti(this,0,-190); //口の座標セット
				if (ttt%60==0) this.ShootR = game.PlayerRadis(this.x-250, this.y-130);
				if (ttt>50 && ttt<300) {
					if(game.LiveShoot() && ttt%8==0 && ttt%60<30) {
						this.DrawSize -= 0.05;
						const r = this.ShootR;
						game.TekiTamaPush(this.x-280, this.y-130,	r[0]*-10,r[1]*-10, r[2]+PI,		new game.OnoShoot(2,1));
						game.PlaySE("Shoot03");		//音
					}
				}
			game.GoMove(this,		350, 0,		100);
			//ナゲット
			} else if (t>500) {
				if (ttt==350) this.ShootR = Math.random()*5;
				if (ttt<480 && ttt%3==0 && game.LiveShoot()) {
					this.DrawSize -= 0.02;
					const r = Math.sin(this.ShootR)*1.5+game.PlayerRadi(this.x-50, this.y-100);
					const sp = (ttt-450)/30+15;
					game.TekiTamaPush(this.x-50, this.y-100,	Math.cos(r)*sp,Math.sin(r)*sp, r,		new game.NikuShoot());
					this.ShootR += 0.3;
					game.PlaySE("Shoot02");		//音
				}
			game.GoMove(this,		450, 0,		100);
			}

			game.AseFunc2(50,-100, 130, index,this.Key);
			//移行
			if (this.Debu > 14000 * helthkake) {
				this.Action = 40;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA02");		//デブ音
				game.FatSE(this, 3, 0);	//デブ音
			}
			break;

		//ぎがでぶ
		case 40:
			this.Size = [100,260];
			game.GoMove(this,		350, Player.y<0 ? 300 : -300,		100);
			img = "Boss15";
			game.Okuti(this,-75,-200); //口の座標セット
			game.AseFunc(this.x+100, this.y-300);
			game.AseFunc2(0,-100, 200, index,this.Key);

			ttt = t%300;
			if (t>100) {
				if (ttt==50) this.ShootR = game.PlayerRadi(this.x-100, this.y-100);
				if (ttt>10) {
					if (t%30==0 && game.LiveShoot()) {
						this.DrawSize -= 0.02;
						let r = this.ShootR + t%60<30 ? TwoPI/16 : 0;
						const sp = (8 + game.Random(3)) * Rank;
						for (let i=0 ; i<TwoPI ;i+=TwoPI/8) {
							game.TekiTamaPush(this.x-100, this.y-100,	Math.cos(r+i)*sp,Math.sin(r+i)*sp, r+i,		new game.NikuShoot());
						}
						this.ShootR += 0.3;
						game.PlaySE("Shoot02");		//音
					}
				}
			}

			//移行
			if (this.Debu > 17000 * helthkake) {
				this.Action = 90;
				this.Timer = 0;
				this.DrawSize = 0.8;
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
				game.FatSE(this, 4, 0);	//デブ音
			}
			break;

		//決着。
		case 90:
			this.Size = false;
			game.GoMove(this,		300, 0,		80);
			img = "Boss18";
			this.x += t%4<2 ? 2 : -2;

			if (t<100) {
				if (t==1) game.SFXPush(this.x, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (t<400) {

			} else {
				this.Live = false;
				game.ScoreMan(2000);		//スコア
			}

			break;
	}


	this.hx += Math.cos(t/32)*0.03;
	this.hy += Math.cos(t/16)*0.06;

	game.Move(this);			//慣性移動
	game.MoveLose(this,0.98);		//摩擦

	//描画
	game.DrawKage(ctxA,GFXs[img],	this.x,this.y,	this.DrawSize + game.PuyoMan(this,17000,0.1),this.DrawSize,	game.Dame(this.Dame),false,	false);


}

//ドクターさん　と　デブエットワーゲン
//==============================================================================================
Game.prototype.DrAndDW = function() {
	this.Size = [80,100];
	this.Action = 0;
	this.AttackTimer = 0;
	this.ShootR = 0;
	this.WalkTimer = 0;
	this.WalkTimer2 = 0;
	this.Jx = 1100,	this.Jy = 60;	//本体座標
	this.CannonRoll = 2;		//主砲実角度
	this.Cannonhx = -1200,		this.Cannonhy = -800;		//主砲目標座標
	this.CannonOff = 250;
	this.NikuTimer = 0;
}
Game.prototype.DrAndDW.prototype.Func = function(index) {

	game.PlayerBuyon(this,false);		//プレーヤー突き飛ばし

	//キホン
	const t = this.Timer;
	let drimg = "Boss200";		//ドクターさんの画像
	let drxoff = -190,	dryoff = -20;	//ドクターさんの座標差分

	//座標
	this.WalkTimer = (this.WalkTimer - (LevelSpeedHX-this.hx) / 55);		//歩き
	const walktimer = this.WalkTimer%TwoPI;
	const walk = -Math.abs(Math.cos(walktimer));		//縦揺れ
	const walklength = 30;								//縦揺れ幅
	const houtoux = this.Jx+40,		houtouy = this.Jy-100 - Math.abs(Math.cos(walktimer+0.1))*walklength;	//砲塔位置
	const houx = houtoux+Math.cos(this.CannonRoll)*520,	houy = houtouy+Math.sin(this.CannonRoll)*520;		//砲先っちょ
	//game.Draw(ctxA,GFXs["Test"],	houx,houy,	1,1,	false,false,	false);	//テスト

	//足音
	const walkt = Math.ceil((this.WalkTimer + HalfPI)/PI);
	if (this.WalkTimer2 != walkt) {
		this.WalkTimer2 = walkt;
		game.PlaySE("Meka00");		//音
	}


	//カノン向き
	/*this.CannonRollH = game.PlayerRadi(houtoux,houtouy);				//プレーヤー狙い
	//ベクトルの外積？
	if (Math.cos(this.CannonRollH)*Math.sin(this.CannonRoll) < Math.sin(this.CannonRollH)*Math.cos(this.CannonRoll)) {
		this.CannonRoll = (this.CannonRoll+0.01) % TwoPI;
	} else {
		this.CannonRoll = (this.CannonRoll-0.01) % TwoPI;
	}*/

	this.CannonRoll = Math.atan2(this.Cannonhy - houtouy,this.Cannonhx - houtoux);	//ゴースト狙い

	this.CannonOff = ((this.CannonOff - 350) * 0.9) + 350;	//カノン食い込み

	//ダメージ
	if (this.Dame) {
		this.DrawSize -= 0.05;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=50) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
	} else {
		//this.Debu += 1;
	}

	//行動
	switch (this.Action) {
		//初肉
		case 0:
			drimg = "Boss201";			//ドクターさんの画像
			game.Okuti(this,-40,-20); //口の座標セット
			drxoff = -190,	dryoff = -40;	//ドクターさんの座標差分
			game.MoveLose(this,0.99);		//摩擦
			if (t == 10) this.hx = -10;
			if (t> 200) {
				this.hx += 0.1;
				//this.Cannon(Player.x,Player.y);		//カノン狙い
			}
			if (t > 300) {
				//移行
				this.Timer = 0;
				this.Action = 10;
				//this.Debu = 10000;
			}
			break;

		//ガリ
		case 10:
			this.Size = [80,100];
			drimg = "Boss200";			//ドクターさんの画像
			game.Okuti(this,-40,-20); //口の座標セット
			drxoff = -190,	dryoff = -40;	//ドクターさんの座標差分
			this.hx += (Player.x+1000>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			if (t%120 > 90) 	this.Cannon(Player.x,Player.y);		//カノン狙い
			if (t>100  && game.LiveShoot()) {
				if (t%120 <90 && t%30==10) {
					this.Fire(houx,houy,houtoux,houtouy);
					let radi = this.CannonRoll;
					let speed = Rank * 6;
					//game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					speed-=2;
					radi += 0.1;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi += -0.2;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi = this.CannonRoll;
					speed = Rank * 6;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));

				}
			}


			//移行
			if (this.Debu > 4000 * helthkake) {
				this.Action = 20;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA00");		//デブ音
				game.FatSE(this, 1, 0);	//デブ音
			}
			break;

		//ぽちゃ
		case 20:
			this.Size = [80,100];
			drimg = this.DameTimer < 5 ? "Boss203" : "Boss202";			//ドクターさんの画像
			game.Okuti(this,-20,-20); //口の座標セット
			drxoff = -190,	dryoff = -40;	//ドクターさんの座標差分
			game.MoveLose(this,0.8);		//摩擦
			this.hx += (Player.x+1000>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き

			if (t>100  && game.LiveShoot()) {
				if (t%450 < 360) {
					this.Cannon(Player.x,Player.y);		//カノン狙い
					if (t%90 <60 && t%10==5) {
						this.Fire(houx,houy,houtoux,houtouy);
						let radi = this.CannonRoll;
						let speed = 5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
					}
				} else {
					if (t%90==5) {
						this.Fire(houx,houy,houtoux,houtouy);
						let radi = this.CannonRoll;
						let speed = 5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll+0.5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll-0.5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll+1;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll-1;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));

					}
				}
			} else {
				this.Cannon(Player.x,Player.y);		//カノン狙い
			}

			//移行
			if (this.Debu > 8000 * helthkake) {
				this.Action = 30;
				this.Timer = 150;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA01");		//デブ音
				game.FatSE(this, 2, 0);	//デブ音
			}
			break;

		//でぶぅ（汗）
		case 30:
			game.AseFunc(this.x+100, this.y-100);
			this.Size = [90,130];
			drimg = "Boss204";			//ドクターさんの画像
			game.Okuti(this,-5,-70); //口の座標セット
			drxoff = -230,	dryoff = -20;	//ドクターさんの座標差分
				
			this.hx += (this.x< (t%300>200 ? 550 :400)) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			if (t%300 >180) 	this.Cannon(Player.x,Player.y);		//カノン狙い
			if (game.LiveShoot()) {
				if (t%300 == 20) {
					this.Fire(houx,houy,houtoux,houtouy);
					let radi = this.CannonRoll - 0.5;
					let speed = 10 * (3-Rank/2);
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));
					radi -= 0.2;
					if (Rank>1.2) game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));

					radi = this.CannonRoll + 0.5;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));
					radi += 0.2;
					if (Rank>1.2) game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));

				}
				if (t%300>200 && t%8 == 0) {

					this.Fire(houx,houy,houtoux,houtouy);
					let radi = this.CannonRoll - (400-t%300) / 100 + 0.8;
					let speed = 20;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi = this.CannonRoll + (400-t%300) / 100 - 0.8;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
				}
			}

			//移行
			if (this.Debu > 10000 * helthkake) {
				this.Action = 40;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA02");		//デブ音
				game.FatSE(this, 3, 0);	//デブ音
			}
			break;

		//でぶでぶ
		case 40:
			game.AseFunc(this.x+100, this.y-150);
			this.Size = [100,160];
			drimg = t%20<10 ? "Boss205" : "Boss206";			//ドクターさんの画像
			game.Okuti(this,-10,-110); //口の座標セット
			drxoff = -270,	dryoff = 30;	//ドクターさんの座標差分
			this.hx += (Player.x+980>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			this.Cannon(Player.x,Player.y);		//カノン狙い

			if (t>200  && game.LiveShoot()) {
				if (t%120 <90 && t%30==0) {
					this.Fire(houx,houy,houtoux,houtouy);
					let radi = this.CannonRoll;
					let speed = 8;
					//game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					speed-=0.5* Rank;
					radi += 0.05;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi -= 0.1;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					if (Rank>1.2) {
						speed-=0.5* Rank;
						radi += 0.05;
						//game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
						radi += 0.1;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
						radi -= 0.2;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					}
					radi = this.CannonRoll;
					speed = 8;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));

				}
			}


			//移行
			if (this.Debu > 15000 * helthkake) {
				this.Action = 50;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				//game.PlaySE("FatA02");		//デブ音
				game.FatSE(this, 4, 0);	//デブ音
			}
			break;

		//ぎがでぶ
		case 50:
			game.AseFunc2(-30,50, 200, index,this.Key);

			this.Size = [200,210];
			drimg = "Boss207";				//ドクターさんの画像
			game.Okuti(this,-50,-210); //口の座標セット
			drxoff = -270,	dryoff = 20;	//ドクターさんの座標差分
			this.hx += (Player.x+1000>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			if (t>100 && game.LiveShoot()) {
				this.Cannon(this.Jx-1800,this.Jy-1000);		//カノン狙い
				if (t%120 <90 && t%12==0) {
					this.Fire(houx,houy,houtoux,houtouy);
					let radi = this.CannonRoll;
					let speed = Math.random()*12 + 1;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, this.CannonRoll,		new game.SoseziShoot(10));
				}
			}

			//移行
			if (this.Debu > 20000 * helthkake) {
				this.Action = 60;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
				game.FatSE(this, 5, 0);	//デブ音
			}
			break;
		//おわり
		case 60:
			game.AseFunc(this.x+100, this.y-250);
			this.Size = false;
			drimg = "Boss207";				//ドクターさんの画像
			drxoff = -270,	dryoff = 20;	//ドクターさんの座標差分
			game.MoveLose(this,0.8);		//摩擦

			if (t<100) {
				this.hx += this.x<200 ? 0.3 : -0.3;	//歩き
				if (t==1) game.SFXPush(this.x-200, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (t<400) {

			} else {
				this.Live = false;
				game.ScoreMan(2000);		//スコア
			}
			break;
	}


	this.Jx += this.hx;			//移動

	//ドクター移動
	this.x = this.Jx + drxoff + Math.cos(this.WalkTimer)*5;
	this.y = this.Jy + dryoff - Math.abs(Math.cos(this.WalkTimer+0.2))*walklength;

	//描画

	//砲身
	game.DrawKage(ctxB,GFXs["Boss253"],	houtoux+Math.cos(this.CannonRoll)*this.CannonOff,houtouy+Math.sin(this.CannonRoll)*this.CannonOff,	1,1,	false,this.CannonRoll,	false);
	//砲
	game.DrawKage(ctxB,GFXs["Boss252"],	houtoux+Math.cos(this.CannonRoll)*90,houtouy+Math.sin(this.CannonRoll)*90,	1,1,	false,this.CannonRoll,	false);

	//砲塔
	game.DrawKage(ctxB,GFXs["Boss251"],	houtoux,houtouy-40,	1,1,	false,false,	false);

	game.DrawKage(ctxA,GFXs[drimg],	this.x,this.y,	this.DrawSize+0.2 + game.PuyoMan(this,20000,0.1),this.DrawSize+0.2,	game.Dame(this.Dame),false,	false);	//ドクターさん

	//脚
	let walkleg = walktimer + HalfPI;
	const cans = [ctxA,ctxA,ctxB,ctxB];
	const legxs = [-100,200,100,-200],	legys = [250,220,200,180];
	const cols = [false, false, "rgba(50,50,50,50)", "rgba(0,0,0,0.3)"]
	for (let i=0 ; i<4 ; i++) {
		const legx = this.Jx+legxs[i],	legy = this.Jy+legys[i];
		game.Draw(cans[i],GFXs["Boss255"],
			legx+50+ game.heriosan(walkleg)*40,	legy+80 - Math.max(0,(Math.cos(walkleg+HalfPI)))*50,
			1,1,	cols[i],Math.cos(walkleg)/6,	false);
		game.DrawKage(cans[i],GFXs["Boss254"],
			legx-90 + game.heriosan(walkleg)*80,	legy+250 - Math.max(0,(Math.cos(walkleg+HalfPI)))*80,
			1,1,	cols[i],-Math.cos(walkleg)/8,	false);
		walkleg += PI;
	}
	//本体
	game.DrawKage(ctxB,GFXs["Boss250"],	this.Jx,this.Jy+150 - Math.abs(Math.cos(this.WalkTimer))*walklength + Math.cos(t)*2,	1,1,	false,false,	false);

	//game.DrawKage(ctxA,GFXs["Test"],	this.Jx,this.Jy,	1,1,	false,false,	false);	//テスト
	//game.DrawKage(ctxA,GFXs["Test"],	legx,legy,	1,1,	false,false,	false);	//テスト

	/*ctxUI.fillStyle = "black";
	ctxUI.textAlign = "left";
	ctxUI.font = "bold 20px 'YuMincho'";
	ctxUI.fillText(walkt, 0, 0);*/
}

Game.prototype.DrAndDW.prototype.Fire = function(houx,houy,houtoux,houtouy) {
	this.CannonOff = 240;
	game.Draw(ctxB,GFXs["Sfx24"],	houx,houy,	1,1,	false,false,	false);
	game.PlaySE("Shoot02");		//音
	game.SFXPush(houtoux,houtouy-40, -3,-12, 0,	new game.DekaShell());
}
Game.prototype.DrAndDW.prototype.Cannon = function(x,y) {
	this.Cannonhx = ((this.Cannonhx - x) * 0.9) + x;	//カノン狙い
	this.Cannonhy = ((this.Cannonhy - y) * 0.9) + y;
}

//ペガサス軍曹
//==============================================================================================
Game.prototype.Pegasasu = function() {
	this.nx = 200,	this.ny = 0;
	this.Size = [60,180];
	this.Action = 0;
	this.AttackTimer = 0;
	this.ShootR = 0;
	this.ShootY = 0;
	this.ShootX = 0;
	this.ShootFat = 0;
	this.AnimeTimer = 0;
	this.NikuTimer = 0;
}
Game.prototype.Pegasasu.prototype.Func = function(index) {
	//キホン
	const t = this.Timer;
	let img = "Test";

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//ダメージ
	if (this.Dame) {
		this.DrawSize -= 0.03;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=40) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
		this.AnimeTimer = 80;
	} else {
	}

	let tt = t;
	let r = 0;
	switch (this.Action) {
		//初肉
		case 0:
			img = "Boss300";
			game.Okuti(this,10,-140); //口の座標セット
			this.y += Math.cos(t/32);
			
			if (t==200) {
				this.Action = 10;
				this.Timer = 0;
				this.Debu = 1000;
			}
			break;

		//痩せ
		case 10:

			img = "Boss300";
			game.Okuti(this,10,-140); //口の座標セット
			this.y += Math.cos(t/32);

			if (t%500<100) {
						this.nx = game.Random(30)+400;
						this.ny = 0;
			} else {
				tt = t%50;
				if (game.LiveShoot()) {

					//移動
					if (tt == 49) {
						this.nx = game.Random(30)+200;
						this.ny = Player.y+90;
					}

					if (tt > 20) {
						img = "Boss301";
						game.Okuti(this,10,-100); //口の座標セット
					}

					//射撃
					/*if (tt < 80 && tt > 60 && tt%5 == 0) {
						const s = (tt-60) / (Rank/2+0.5);
						game.TekiTamaPush(this.x-120, this.y-90,	-s,0, PI,		new game.TeiShoot());
						game.PlaySE("Shoot01");		//音
						this.DrawSize = 0.9;
						this.hx += 5;
					}*/

					if (tt==45) {
						const s = 8;
						for (let i=-4 ; i<5 ; i++) game.TekiTamaPush(this.x-120, this.y-90 + i*15*Rank,	-s,0 + i/10, PI,		new game.TeiShoot());
						game.PlaySE("Shoot01");		//音
						this.DrawSize = 0.9;
						this.hx += 15;
					}

				}
			}

			//移行
			if (this.Debu > 3500 * helthkake) {
				this.Action = 20;
				this.Timer = 0;
				this.DrawSize = 0.5;
				//game.PlaySE("FatA00");		//音
				game.FatSE(this, 1, 0);	//デブ音
				this.Size = [100,180];
			}
			break;

		//ふとめ
		case 20:
			//if (t%1000 < 500) {
			if (t < 500) {

				//const tt = t%1000;
				const tt = t;

				//7WAY
				img = "Boss320";
				game.Okuti(this,0,-140); //口の座標セット
				this.y += Math.cos(t/32);
				//移動
				if (t%80 == 0) {
					this.nx = game.Random(100)+300;
					this.ny = game.Random(100)+100;

					this.hx += game.Random(10);
					this.hy += game.Random(10);
				}

				if (tt%40 == 0 && tt>60 && t>100) {
					if (game.LiveShoot()) {
						const r = game.PlayerRadi(this.x-100, this.y-200);

						//撃つ
						const s = 10 + game.Random(5);
						const rl = 0.5;
						for (let i=-rl*3 ; i<=rl*3 ; i+=rl) {
							game.TekiTamaPush(this.x-100, this.y-200,	Math.cos(r+i)*s,Math.sin(r+i)*s, r+i,		new game.TeiShoot());
						}
						game.PlaySE("Shoot01");		//音
						this.DrawSize = 0.9;
					}
				}

			} else {
				//ワインダー

				//const tt = t%1000-500;
				tt = t-500;

				if (tt < 20) {
					//振りかぶり
					img = "Boss321";
					game.Okuti(this,-40,0); //口の座標セット
					game.MoveLose(this,0.93);		//摩擦
					if (tt == 2) {
						this.hx += 20;
						//this.hy += 20;
						this.nx = 400;
					}
					//this.hx += 1;
				} else {
					//背
					this.hx *= 0,95;
					this.nx = Math.max(300, this.nx - 0.2);
					img = "Boss322";
					//if (tt == 50) this.ShootR = game.PlayerRadi(this.x,this.y);

					const length = 300;	//振る上限	

					//撃ちだす瞬間の設定
					if (tt == 50) {
						this.ShootX = Player.x;
						this.ShootY = Player.y;
						this.ShootFat = Player.y<0;
					}

					//移行か切り替えし
					if (tt>350) {

						if (Math.random()<0.3) {
							//切り返し
							this.ShootFat = Player.y<0;
							this.Timer = 600;

						} else {
							//移行
							this.Timer = 0;
						}
					}

					//連射
					if (tt > 50) {
						//if (t%5 == 0 && game.LiveShoot()) {
						if (t%5 == 0) {

							//上下に振る
							if (tt>200 && tt<300) {
								//const rl = 0.1;
								//r += Math.sin((tt-200)/12) * 0.1;

								const Pls = 15;
								this.ShootY += (this.ShootFat ? Pls : -Pls);
							}

							this.ShootY = Math.min(length, Math.max(-length,this.ShootY));
							let r = game.Radi(this.x,this.y, this.ShootX,this.ShootY );

							//撃つ
							//const s = Math.min(40, tt-50)+10;
							const s = 50;
							for (let i=-0.5 ; i<=0.5 ; i+=0.5) {
								game.TekiTamaPush(this.x+30, this.y+200,	Math.cos(r+i)*s,Math.sin(r+i)*s, r+i,		new game.HaneShoot());
							}
							for (let i=-0.5 ; i<=0.5 ; i+=0.5) {
								game.TekiTamaPush(this.x+30, this.y-200,	Math.cos(r+i)*s,Math.sin(r+i)*s, r+i,		new game.HaneShoot());
							}
							game.PlaySE("Shoot02");		//音
						}
					}
				}
			}

			//移行
			if (this.Debu > 10000 * helthkake) {
				this.Action = 30;
				this.Timer = 100;
				this.DrawSize = 0.5;
				//game.PlaySE("FatA02");		//音
				game.FatSE(this, 2, 0);	//デブ音

				this.ShootFat = true;
				this.ShootR = 0;

				this.Size = [150,220];
			}
			break;

		//巨デブ
		case 30:

			if (t > 280) {
				img = "Boss331";
				game.Okuti(this,20,-165); //口の座標セット
			} else {
				img = "Boss330";
				game.Okuti(this,10,-175); //口の座標セット
			}

			//移動
			this.ny = Math.sin(Loop/128) * 150;

			if (t<300) {
				this.nx = 200;
			} else {
				this.nx = Math.min(500, this.nx+1);
			}
			//if () {

				if (this.ShootFat) {

					//ばら撒き
					if (t > 300 && t%20 == 0 && game.LiveShoot()) {
						const s = 8 * Rank;
						const r = Math.max(-0.6,Math.min(0.6,	Math.cos(this.ShootR)	)) + PI;
						if (t%40 < 5) {
							game.TekiTamaPush(this.x-200, this.y-130,	Math.cos(r)*s,Math.sin(r)*s, r,		new game.TeiShoot());
							game.TekiTamaPush(this.x-200, this.y+130,	Math.cos(r)*s,Math.sin(r)*s, r,		new game.TeiShoot());
						} else {
							const rr = TwoPI-r;
							game.TekiTamaPush(this.x-200, this.y-130,	Math.cos(rr)*s,Math.sin(rr)*s, rr,		new game.TeiShoot());
							game.TekiTamaPush(this.x-200, this.y+130,	Math.cos(rr)*s,Math.sin(rr)*s, rr,		new game.TeiShoot());
						}
						game.PlaySE("Shoot01");		//音
						this.DrawSize = 0.9;
						this.ShootR += PI/16;
					}
				} else {
					//羽
					if (t > 400 && t%5 == 0) {
						const rt = Loop/64;
						const plsr = TwoPI/3;
						game.TekiTamaPush(this.x-190, this.y+Math.cos(rt)*100,	-40,0, PI,		new game.HaneShoot());
						game.TekiTamaPush(this.x-190, this.y+Math.cos(rt+plsr)*100,	-40,0, PI,		new game.HaneShoot());
						game.TekiTamaPush(this.x-190, this.y+Math.cos(rt+plsr+plsr)*100,	-40,0, PI,		new game.HaneShoot());
						game.PlaySE("Shoot02");		//音
						this.DrawSize -= 0.01;
					}
				}

			//}

			if (t > 500 && t%30 == 0 && Math.random()<0.1) {
				this.Timer = Math.ceil(150 + Math.random()*100);
				this.ShootFat = Math.random()<0.7;;
			}

			//移行
			if (this.Debu > 19000 * helthkake) {
				this.Action = 40;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.PlaySE("FatA02");		//音
				game.FatSE(this, 3, 0);	//デブ音
				this.Size = [230,230];
				this.nx = 250;
			}
			break;

		//メガデブ
		case 40:
			game.AseFunc(this.x+50, this.y-250);

			tt = t%300;

			const imgs = ["Boss340",	"Boss342",	"Boss340",	"Boss341"];
			img = imgs[Math.ceil(this.AnimeTimer/2)%4];
			this.AnimeTimer *= 0.95;
			game.Okuti(this,-95,-160); //口の座標セット

			//移動
			this.ny = Math.sin(Loop/128) * 200;

			if (game.LiveShoot()) {

				//射撃
				if (tt > 50 && tt%30 == 0) {
					const s = 8 * Rank;

					game.PlaySE("Shoot01");		//音
					game.TekiTamaPush(this.x-100+game.Random(100), this.y+game.Random(200),	-s,0, PI,		new game.NInzinShoot());
					this.DrawSize = 0.95;
					this.hx += 5;
				}

				if (t > 300) {

					let r = (t)%TwoPI;

					if (r<TwoPI-0.5 && r>0.5) {
						r += PI;
						const s = 15;
						game.TekiTamaPush(this.x+Math.cos(r)*200, this.y+Math.sin(r)*200,	Math.cos(r)*s,Math.sin(r)*s,r,		new game.HaneShoot());
					}
				}

			}

			//移行
			if (this.Debu > 25000 * helthkake) {
				this.Action = 500;
				this.Timer = 0;
				this.DrawSize = 0.2;
				game.PlaySE("FatA02");		//音
				game.FatSE(this, 4, 0);	//デブ音
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
				//this.nx = 200;
				//this.ny = 0;
				this.Size = false;
			}
			break;

		//脂肪
		case 500 :

			this.x += Loop4 ? -3 : 3;

			img = "Boss343";

			if (t<100) {
				if (t==1) game.SFXPush(this.x, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (t<400) {
			} else {
				this.Live = false;
				game.ScoreMan(3000);		//スコア
			}
			break;
	}

	game.Move(this);				//慣性移動
	game.MoveLose(this,0.95);		//摩擦
	game.GoMove2(this, this.nx, this.ny, 0.03);		//座標指定

	//描画
	game.DrawKage(ctxA,GFXs[img],	this.x, this.y,	this.DrawSize + game.PuyoMan(this,25000,0.1),this.DrawSize,	game.Dame(this.Dame),false,	false);

}

//代表取締役ティラノさん
//==============================================================================================
Game.prototype.Thirano = function() {
	this.Size = [100,260];
	this.Action = 0;
	this.ActionTimer = 0;
	this.Phase = 0;

	this.WalkTimer = 0;
	this.WalkTimer2 = 0;
	this.Kagami = 0;
	this.MabatakiTimer = 0;
	this.NikuByoTimer = 0;
	this.Okutix = 0;	this.Okutiy = 0;
	this.ShootTimer = 0;

	this.NikuTimer = 0;
}
Game.prototype.Thirano.prototype.Func = function(index) {
	//キホン
	const t = this.Timer;
	let kaogfx = null;
	let kagami = null;

	//const fatsize = Math.sin(Loop/128)/2+0.5;	//太さ（0～1）
	//const fatsize = Math.sin(Loop/128)+1;	//太さ（0～1）
	const fatsize = Math.min(1, this.Debu/14000);	//太さ（0～1）

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	game.Move(this);				//慣性移動
	game.MoveLose(this,0.95);		//摩擦
	this.y = 100;

	if(this.Action >= 900) {
		this.Size = [0,0];
	} else {
		this.Size = [100 + fatsize*200,260];
	}

	let okutix = this.Okutix, okutiy = this.Okutiy;

	//ダメージ
	if (this.Dame) {
		//this.DrawSize -= 0.05;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=300) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
	} else {
		//this.Debu = Math.max(0,this.Debu-=2);
		//this.Debu += 1;
	}

	const at = this.ActionTimer;
	this.ActionTimer++;

	switch (this.Action) {

		//初肉
		//----------------
		case 0:

			this.hx += (this.x < Math.min(400,300)) ? 0.1 : -0.1;
			
			if (t==300) {
				this.Action = 100;
				this.ActionTimer = 0;
				this.Phase = 0;
			}
			break;


		//攻撃
		//----------------
		case 100:{
			const att = this.ActionTimer%120;
			//移動
			this.hx += (this.x < Math.min(400,Player.x+800 - 100*fatsize)) ? 0.1 : -0.1;

			//攻撃パターン変更
			if(att == 119) {
				this.Phase = Math.floor(Math.random()*7);
			}
			if(att<100) {
				//攻撃パターン
				switch (this.Phase) {

					//拡散
					case 0:{
						if(att%30==1) {
							this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(0+game.Random(50),game.Random(300)));
						}
						}break;

					//拡散多
					case 1:{
						if(att%30==1) {
							this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(0+game.Random(50),game.Random(300)));
							game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(0+game.Random(50),game.Random(300)));
						}
						}break;

					//縦
					case 2:{
						if(att==50) {
							this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							for(let i=-5 ; i<=5 ; i++) game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(0,i*80));
						}
						}break;

					//上
					case 3:{
						if(att==50) {
							this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							for(let i=0 ; i<7 ; i++) game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(i*-80,-300));
						}
						}break;

					//下
					case 4:{
						if(att==50) {
							this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							for(let i=0 ; i<7 ; i++) game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(i*-80,300));
						}
						}break;

					//Way
					case 5:{
						if(att==30) {
							//this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							const speed = 10 - 3*Rank;
							for(let i=-5 ; i<5 ; i++){
								game.TekiTamaPush(this.x-100, 0,	Math.cos(PI+i*0.3)*speed,Math.sin(PI+i*0.3)*speed, 0,		new game.NikuShoot());
								game.TekiTamaPush(this.x-100, 0,	Math.cos(PI+i*0.3)*speed*0.9,Math.sin(PI+i*0.3)*speed*0.9, 0,		new game.NikuShoot());
								//game.TekiTamaPush(this.x-100, 0,	Math.cos(PI+i*0.3)*speed*0.8,Math.sin(PI+i*0.3)*speed*0.8, 0,		new game.NikuShoot());
							}
						}
						}break;

					//ばら撒き
					case 6:{
						if(att>30 && att%2==0) {
							//this.ShootTimer = 20;
							//game.PlaySE("Shoot02");		//音
							const speed = 6 + 3*Rank;
							const r = Math.sin(t/12)*(3 - Rank*0.5)+PI;
							game.TekiTamaPush(this.x-100, 0,	Math.cos(r)*speed,Math.sin(r)*speed, 0,		new game.NikuShoot());
							//game.TekiTamaPush(this.x-100, 0,	Math.cos(r)*speed,-Math.sin(r)*speed, 0,		new game.NikuShoot());
						}
						}break;

					default:
						break;
				}
			}

			//移行
			if(this.Debu>7000) {
				this.Action = 200;
				this.ActionTimer = 0;
				this.Phase = 0;
				game.NikuFunc(this.x, this.y, 5);
				game.FatSE(this, 3, 0);	//デブ音
				this.hx = 5;
			}

			}break;

		//のけ反り
		//----------------
		case 200:{
			//移動
			this.hx += at<100 ? 0.1 : -0.1;
			kagami = 1;
			//移行
			if(at>200) {
				this.Action = 210;
				this.ActionTimer = 0;
				this.Phase = 0;
				//game.FatSE(this, 3, 0);	//デブ音
			}

			}break;
	
		//攻撃
		//----------------
		case 210:{
			const att = this.ActionTimer%80;
			//移動
			this.hx += (this.x < Math.min(400,Player.x+800 - 100*fatsize)) ? 0.1 : -0.1;

			//攻撃パターン変更
			if(att == 79) {
				this.Phase = Math.floor(Math.random()*5);
			}
			if(att<70) {
				//攻撃パターン
				switch (this.Phase) {

					//視力検査
					/*case 0:
					case 3:
					case 1:{
						if(att==10) {
							//this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							let r = 0;
							for(let i=-0.6 ; i<=0.6 ; i+=0.1) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(Math.max(-500,Player.x)+Math.cos(i+r)*400,Player.y+Math.sin(i+r)*400));
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(Math.max(-500,Player.x)+Math.cos(i+r)*500,Player.y+Math.sin(i+r)*500));
								//r+=PI;
								//game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(Math.max(-400,Player.x)+Math.cos(i+r)*300,Player.y+Math.sin(i+r)*300));
							}
						}

						}break;*/
					//上下
					case 0:
					case 1:{
						if(att==10) {
							//this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							let r = 0;
							for(let i=-0.5 ; i<=0.5 ; i+=0.1) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(-320+Math.cos(i+r)*300,Math.sin(i+r)*300));
								r+=PI;
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(-320+Math.cos(i+r)*300,Math.sin(i+r)*300));
							}
						}
						}break;
					//左右
					case 2:
					case 3:{
						if(att==10) {
							//this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							let r = HalfPI;
							for(let i=-0.5 ; i<=0.5 ; i+=0.1) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(-320+Math.cos(i+r)*300,Math.sin(i+r)*300));
								r+=PI;
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(-320+Math.cos(i+r)*300,Math.sin(i+r)*300));
							}
						}
						}break;

					//上
					/*case 0:{
						if(att==10) {
							//this.ShootTimer = 20;
							for(let i=-1 ; i<8 ; i++) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(i*-60,-300 + i*i));
							}
						}
						}break;
					//下
					case 1:{
						if(att==10) {
							//this.ShootTimer = 20;
							for(let i=-1 ; i<8 ; i++) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(i*-60,400 - i*i));
							}
						}
						}break;
					//左
					case 2:{
						if(att==10) {
							//this.ShootTimer = 20;
							for(let i=-5 ; i<5 ; i++) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(-WidthHalf+50 + Math.abs(i*i),i*60));
							}
						}
						}break;*/
					//右
					/*case 3:{
						if(att==10) {
							//this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							for(let i=-7 ; i<7 ; i++) {
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(Player.x + 500 - Math.abs(i*i),i*60));
								game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(Player.x + 550 - Math.abs(i*i),i*60));
							}
						}
						}break;*/

					//Way
					case 4:{
						if(att==10) {
							//this.ShootTimer = 20;
							game.PlaySE("Shoot02");		//音
							const speed = 12 - 3*Rank;
							for(let i=-5 ; i<5 ; i++){
								game.TekiTamaPush(this.x, 0,	Math.cos(PI+i*0.4)*speed,Math.sin(PI+i*0.4)*speed, 0,		new game.NikuShoot());
								//game.TekiTamaPush(this.x, 0,	Math.cos(PI+i*0.4)*speed*0.9,Math.sin(PI+i*0.4)*speed*0.9, 0,		new game.NikuShoot());
								//game.TekiTamaPush(this.x, 0,	Math.cos(PI+i*0.4)*speed*0.8,Math.sin(PI+i*0.4)*speed*0.8, 0,		new game.NikuShoot());
							}
						}
						}break;
					default:
						break;
				}
			}

			//移行
			if(this.Debu>14000) {
				this.Action = 300;
				this.ActionTimer = 0;
				this.Phase = 0;
				game.NikuFunc(this.x, this.y, 5);
				game.FatSE(this, 4, 0);	//デブ音
			}

			}break;

		//のけ反り2
		//----------------
		case 300:{
			kaogfx = "Boss406";
			//移動
			this.hx += at<50 ? 0.1 : -0.1;
			kagami = 1;
			//移行
			if(at>100) {
				this.Action = 310;
				this.ActionTimer = 0;
				this.Phase = 0;
				//game.FatSE(this, 3, 0);	//デブ音
			}

			}break;

		//やけくそ
		//----------------
		case 310:{
			kaogfx = "Boss406";

			//移動
			this.hx += (this.x < Math.min(400,Player.x+800 - 100*fatsize)) ? 0.1 : -0.1;
			kagami = 1;

			//if(att>200 && att%80==0) game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(0+game.Random(50),game.Random(300)));
			if(at%3==0) {
				//this.ShootTimer = 20;
				//game.PlaySE("Shoot02");		//音
				const speed = 6 + 3*Rank;
				const r = Math.sin(t/32)*2 + at/6;
				game.TekiTamaPush(this.x, 0,	Math.cos(r)*speed,Math.sin(r)*speed, 0,		new game.NikuShoot());
				game.TekiTamaPush(this.x+30, 0,	Math.cos(r)*speed,Math.sin(r)*speed, 0,		new game.NikuShoot());
				game.TekiTamaPush(this.x+60, 0,	Math.cos(r)*speed,Math.sin(r)*speed, 0,		new game.NikuShoot());
			}


			//移行
			if (this.Debu > 17000) {
				this.Action = 900;
				this.ActionTimer = 0;
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
				game.FatSE(this, 5, 0);	//デブ音
			}

			}break;

		//死亡
		//----------------
		case 900:
			kaogfx = "Boss406";

			//this.x += Loop4 ? -3 : 3;
			this.hx = 0;

			if (at<100) {
				if (at==1) game.SFXPush(this.x, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (at<400) {
			} else {
				this.Live = false;
				game.ScoreMan(4000);		//スコア
			}

			break;
	}

	/*if(t%200<100) {
		kagami = 1;
		if(t%30==0) {
			this.ShootTimer = 20;
			game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(100+game.Random(50),game.Random(300)));
			game.TekiTamaPush(okutix, okutiy,	0,0, 0,		new game.FireShoot(100+game.Random(50),game.Random(300)));
		}
	}*/

	//吐いたらかがむ
	if(this.ShootTimer > 0) {
		kagami = -1.5;
		kaogfx = "Boss405";
	}
	this.ShootTimer = Math.max(0,this.ShootTimer-1);

	//歩行
	{

		//歩く
		this.WalkTimer += LevelSpeedX*0.015 - this.hx * 0.01;


		const wt = this.WalkTimer;		//歩行ラジアン
		const walksin = Math.sin(wt);


		const fatlength = 1-fatsize;				//動きの大きさ(1~2)
		const ikit = this.Timer/20;
		const iki = Math.sin(ikit) * fatsize;	//息（-1~1）

		//const ikigire = fatsize>0.7;
		const ikigire = this.Action>100;

		//かがみ具合（ー１～1）
		if(kagami == null || ikigire) {
			kagami = Math.min(1,Math.max(-1,(this.Kagami-Player.y-200)/200)) + fatsize - iki;
		} else {
			kagami;
		}
		this.Kagami = game.Name2(this.Kagami, kagami,0.05);
		kagami = this.Kagami;

		//おにくﾌﾞﾙﾝ
		//if(Math.abs(this.WalkTimer%PI)<1 ) this.NikuByoTimer = 1;
		this.NikuByoTimer = Math.max(0, this.NikuByoTimer - 0.05);
		//this.NikuByoTimer *= 0.9;
		const sizpls = 1 + ((Math.sin(Loop/2) * this.NikuByoTimer)*0.2)*fatsize;

		//足踏みタイミング
		const walkt = Math.ceil((this.WalkTimer)/PI);
		if (this.WalkTimer2 != walkt) {
			this.WalkTimer2 = walkt;
			game.PlaySE("Step00",fatsize,1.7-fatsize);		//音

			this.NikuByoTimer = 1;
			LevelQuakeTimer = fatsize;
		}




		//腰
		const kosix = this.x ;
		const kosiy = this.y + 200+ -Math.abs(walksin*40);

		//game.DrawKage(ctxA,GFXs["Boss400"],	kosix, 	kosiy,	1+fatsize,1,	game.Dame(this.Dame),	0,	false);

		//首
		const kubix = kosix + kagami*60;
		const kubiy = kosiy-300;

		//肩甲骨あたり
		game.DrawKage(ctxA,GFXs["Boss420"],	kubix, kubiy+30 + iki*10 - 30*fatsize,
			1+fatsize/5 + walksin/4,1.2,	game.Dame(this.Dame),	0,	false);

		//ちち
		game.DrawKage(ctxA,GFXs["Boss422"],	kosix + kagami*60 + walksin*-10 -80*fatsize - 80,		kosiy - 200 + Math.sin(wt*2-3)*30*fatsize - 50*fatsize,
			0.8+fatsize*1.1, 0.8+fatsize*0.8 * sizpls*1.1,			game.Dame(this.Dame),	kagami/7,	false);

		//下腹
		game.DrawKage(ctxA,GFXs["Boss431"],	kosix + kagami*20,		kosiy - 70 + Math.sin(wt*2-4)*60*fatsize + 40*fatsize,
			0.8+fatsize*1.3 * sizpls, 1+fatsize*1.4,	game.Dame(this.Dame),	0,	false);
		//上腹
		game.DrawKage(ctxA,GFXs["Boss430"],	kosix + kagami*40,		kosiy - 150 + Math.sin(wt*2-3.5)*40*fatsize + 20*fatsize,
			0.8+fatsize*1.3 * sizpls, 1+fatsize*0.6,	game.Dame(this.Dame),	kagami/10,	false);

		//顔
		const kao_radi = (kagami/3) - 1.8 - Math.cos(ikit-HalfPI)*fatsize*0.2;				//首の角度
		const kaox = kubix + Math.cos(kao_radi) * 100;
		const kaoy = kubiy + Math.sin(kao_radi) * 100;
		const mukir = game.Radi(kaox, kaoy, Math.min(this.x-100,Player.x),Player.y*0.8) + (fatsize/2);	//顔の向き

		//襟
		game.DrawKage(ctxA,GFXs["Boss440"],	(kaox+kubix)/2, (kaoy+kubiy)/2,
			0.8,0.8,	false,					kao_radi,	false);

		//顔
		if(kaogfx != null) {

		} else if(ikigire){
			kaogfx = iki>0 ? "Boss403" : "Boss404"
		} else {
			kaogfx = this.MabatakiTimer>0 ? "Boss402" : "Boss401";
		}
		game.DrawKage(ctxA,GFXs[kaogfx],	kaox, kaoy,
			1.4 + fatsize*0.2,1.4,	game.Dame(this.Dame),	mukir+PI,	false);
		this.Okutix = kaox + Math.cos(mukir-0.5)*50
		this.Okutiy = kaoy + Math.sin(mukir-0.5)*50
		game.Okuti(this,	this.Okutix - this.x,	this.Okutiy - this.y); //口の座標セット

		//瞬き
		if(Math.random()*50<1 && this.MabatakiTimer<-20) this.MabatakiTimer = 10;
		this.MabatakiTimer--;

		//ちち
		game.DrawKage(ctxA,GFXs["Boss421"],	kosix + kagami*60 + walksin*20,				kosiy - 200 + Math.sin(wt*2-3)*30*fatsize - 50*fatsize,
			0.8+fatsize*1.1, 0.8+fatsize*0.8 * sizpls*1.1,			game.Dame(this.Dame),	kagami/7,	false);

		//腕
		for(let i=0 ; i<2 ; i++) {

			const m = i==0;
			const ctx = m ? ctxA : ctxB;
			const katax = kubix + ((100 + walksin*20) * (m ? 1 : -1)) + kagami*fatsize*30;
			const katay = kubiy + iki*20 - 50*fatsize + kagami*fatsize*20;

			const ninoude_radi = Math.sin(wt-1) * (m ? -1 : 1) * (0.9 * (fatlength+0.1)) + HalfPI;	//肩からの角度
			const ude_length = 200;													//腕の長さ

			//ひじ
			const hizix = katax + Math.cos(ninoude_radi) * ude_length;
			const hiziy = katay + Math.sin(ninoude_radi) * ude_length;
				//game.DrawKage(ctx, GFXs["Test"],	hizix, hiziy,1,1,	false,	0,	false);//テスト

			//二の腕
			game.DrawKage(ctx, GFXs[(fatsize<0.6 ? "Boss411" : "Boss413")],	(hizix+katax)/2, (hiziy+katay)/2,
				1.2 + fatsize*0.3, 0.7+fatsize*2 * sizpls,	game.Dame(this.Dame),	ninoude_radi,	false);

			//肩
			game.DrawKage(ctx, GFXs["Boss410"],	katax, katay,
				1.1,0.9+fatsize*1.7 * sizpls,	game.Dame(this.Dame),	ninoude_radi,	false);

			//手
			const hizi_radi = ninoude_radi + Math.sin(wt-3) * (m ? -1 : 1) * (0.4 ) + 1;			//肘からの角度
			const otetex = hizix + Math.cos(hizi_radi) * ude_length;
			const otetey = hiziy + Math.sin(hizi_radi) * ude_length;
				//game.DrawKage(ctx, GFXs[i ? "Boss460" : "Boss461"],	otetex, otetey,1,1,	false,	0,	false);//テスト

			//前腕
			game.DrawKage(ctx, GFXs["Boss412"],	(hizix+otetex)/2, (hiziy+otetey)/2,
				1, 0.7+fatsize*0.8 * sizpls,	game.Dame(this.Dame),	hizi_radi,	false);

			//おてて
			game.DrawKage(ctx, GFXs[i ? "Boss461" : "Boss460"],	otetex, otetey,
				1.1,1.1+fatsize/4,	game.Dame(this.Dame),	hizi_radi + Math.sin(wt-5) * 0.3 * fatlength + 0.5,	false);
		}

		//しっぽ
		game.DrawKage(ctxB,GFXs["Boss470"],	kosix+100, kosiy-60,
			0.5, 0.5,	game.Dame(this.Dame),	-Math.abs(walksin)/3 + kagami + 1,	false);

		//脚
		game.DrawKage(ctxB,GFXs["Boss451"],	kosix-50 + walksin*50, kosiy+110,
			0.8+fatsize*1.5 * sizpls, 1,	game.Dame(this.Dame),	walksin/3,	false);

		//腰
		game.DrawKage(ctxB,GFXs["Boss450"],	kosix, kosiy+20,
			0.7+fatsize * sizpls*1.2 - walksin/8, 1+fatsize/3,	game.Dame(this.Dame),	0,	false);

		//脚
		game.DrawKage(ctxB,GFXs["Boss451"],	kosix+50 - walksin*50, kosiy+110,
			0.8+fatsize*1.5 * sizpls, 1,	game.Dame(this.Dame),	walksin/3,	false);


		//あせ
		if(fatsize>0.7) game.AseFunc(kaox+100, kaoy-50);
		if(fatsize>0.3) game.AseFunc2(0,0, 200, index,this.Key);
		if(fatsize>0.5) game.AseFunc2(0,100, 300, index,this.Key);
		if(fatsize>0.8) game.AseFunc2(0,200, 400, index,this.Key);
	}
}
//==============================================================================================
//==============================================================================================
//==============================================================================================