//自機弾プッシュ
Game.prototype.ZikiTamaPush = function(x,y,hx,hy,radi,data) {
	const i = game.NullFined(ZikiTamas);
	ZikiTamas[i]=data;
	//そして基本的情報を挿入
	game.TamaKiso(ZikiTamas[i],x,y,hx,hy,radi);
}

//敵弾プッシュ
Game.prototype.TekiTamaPush = function(x,y,hx,hy,radi,data) {
	const i = game.NullFined(TekiTamas);
	TekiTamas[i]=data;
	//基本的情報を挿入
	game.TamaKiso(TekiTamas[i],x,y,hx,hy,radi);
}

//エフェクトプッシュ
Game.prototype.SFXPush = function(x,y,hx,hy,radi,data) {
	const i = game.NullFined(SFXs);
	SFXs[i]=data;
	//そして基本的情報を挿入
	game.TamaKiso(SFXs[i],x,y,hx,hy,radi);
}

//弾の基本情報
Game.prototype.TamaKiso = function(data,x,y,hx,hy,r) {
	data.Live = true;				//生存確認
	data.x = x,		data.y = y;		//座標
	data.hx = hx,	data.hy = hy;	//慣性（任意）
	data.Radi = r;					//方角性（任意）
	data.Timer = 0;					//タイマー

}

//==============================================================================================
//==============================================================================================
//エフェクトスプライト
//==============================================================================================
//==============================================================================================


//汗
//==============================================================================================
Game.prototype.Ase = function() {
}
Game.prototype.Ase.prototype.Func = function(index) {
	if (this.Timer < 20) {
		this.hx = Math.cos(this.Radi)*5;
		this.hy = Math.sin(this.Radi)*5;
		game.Move(this);		//慣性移動
		this.Radi += 0.02;
		var size = 1-this.Timer/20
		game.Draw(ctxA,GFXs["Sfx02"],	this.x,this.y,	size,size,	false,this.Radi,	false);
	} else {
		this.Live = false;
	}
}

//汗2
//==============================================================================================
Game.prototype.Ase2 = function(ind,key,gx,gy) {
	this.Index = ind,	this.Key = key;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Ase2.prototype.Func = function(index) {
	if (this.Timer < 300) {
		if (this.Timer<100 && game.CallSprite(this.Index,this.Key)) {
			this.x = Sprites[this.Index].x + this.gx;
			this.y = Sprites[this.Index].y + this.gy;
			this.gy += 0.5;
		} else {
			this.hy += 0.2;
			game.Move(this);		//慣性移動
			game.GamenOut(this);	//画面外消失
		}
		const size = Math.min(1, this.Timer/50)*0.8;
		game.Draw(ctxA,GFXs["Sfx03"],	this.x,this.y,	size,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//花火
//==============================================================================================
Game.prototype.Stars = function() {
}
Game.prototype.Stars.prototype.Func = function(index) {
	if (this.Timer < 120) {
		const size = Math.sin(this.Timer/120*PI)*200;
		const sizee = 1-Math.sin(this.Timer/120*HalfPI);
		for (let r=this.Timer/20 ; r<8 ; r+=TwoPI/8) {
			game.Draw(ctxA,GFXs[Loop8 ? "Sfx23" : "Sfx20"],this.x+Math.cos(r)*size,this.y+Math.sin(r)*size,
				sizee,sizee,	false,0,	false);	
		}
		if (this.Timer<30) {
			const sizeee = 1-Math.sin(this.Timer/30*HalfPI);
			game.Draw(ctxA,GFXs["Sfx21"],this.x,this.y,	sizeee,sizeee,	
			Loop4 ? "rgba(255,0,0,0.8)" : "rgba(255,255,0,0.8)",0,	false);
		}
	} else {
		this.Live = false;
	}
}

//肉火花
//==============================================================================================
Game.prototype.FatSlag = function() {
}
Game.prototype.FatSlag.prototype.Func = function(index) {
	if (this.Timer < 30) {
		game.Move(this);			//慣性移動
		game.MoveLose(this, 0.98);		//摩擦
		const size = Math.sin(this.Timer/30*PI);
		game.Draw(ctxA,GFXs["Sfx00"],	this.x,this.y,	size,size,	false,this.Radi,	false);
	} else {
		this.Live = false;
	}
}
//肉火花2
//==============================================================================================
Game.prototype.FatSlag2 = function() {
}
Game.prototype.FatSlag2.prototype.Func = function(index) {
	if (this.Timer < 40) {
		game.Move(this);			//慣性移動
		game.MoveLose(this, 0.95);		//摩擦
		const size = Math.sin(this.Timer/40*HalfPI + HalfPI);
		game.Draw(ctxB,GFXs["Sfx01"],	this.x,this.y,	size,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//飛び散った脂肪片
//==============================================================================================
Game.prototype.FatBall = function() {
	this.Size = Math.random()/2+0.5;
}
Game.prototype.FatBall.prototype.Func = function(index) {
	//this.hy += this.Size/6;
	this.hy += 0.08;
	game.Move(this);			//慣性移動
	img = ["Sfx40","Sfx41","Sfx42","Sfx43"];
	img = GFXs[img[Math.floor(index%4)]];

	const size = Math.sin(this.Timer/30*PI);
	game.Draw(ctxB,img,	this.x,this.y,	this.Size+((Math.random()-0.5)/4),this.Size+((Math.random()-0.5)/4),
		false,false,	false);
	game.GamenOut(this);	//画面外消失
}

//汎用飛沫
//==============================================================================================
Game.prototype.Himatu = function(i) {
	this.Roll = Math.random() * PI;
	this.IMG = i;
	this.End = 80 + Math.random()*50;
}
Game.prototype.Himatu.prototype.Func = function(index) {
	if (this.Timer < this.End) {
		game.Move(this);			//慣性移動
		//game.MoveLose(this,0.98);		//摩擦
		this.hy+=0.2;
		game.Draw(ctxB,GFXs[this.IMG],	this.x,this.y,	1,1,	false,this.Roll,	false);
		//game.GamenOut(this);	//画面外消失
	} else {
		this.Live = false;
	}
}

//血
//==============================================================================================
Game.prototype.Ti = function() {
	this.Size = Math.random()/2+0.5;
}
Game.prototype.Ti.prototype.Func = function(index) {
	if (this.Timer < 60) {
		game.Move(this);			//慣性移動
		game.MoveLose(this, 0.98);		//摩擦
		this.hy+=0.4;
		const size = Math.sin(this.Timer/60*HalfPI + HalfPI);
		game.Draw(ctxB,GFXs["Sfx52"],	this.x,this.y,	size,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//自機のマズルフラッシュ
//==============================================================================================
Game.prototype.ShootSibuki = function(psize=1) {
	this.Size = Math.random()/2+0.5;
	this.Psize = psize;
}
Game.prototype.ShootSibuki.prototype.Func = function(index) {
	if (this.Timer < 8) {

		const size = (8-this.Timer)/8;
		game.Draw(ctxA,GFXs["Sfx04"],	this.x,this.y,	(1-size)*this.Psize,size*this.Psize,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//デカ薬莢
//==============================================================================================
Game.prototype.DekaShell = function() {
}
Game.prototype.DekaShell.prototype.Func = function(index) {
	//this.hy += this.Size/6;
	this.hy += 0.3;
	game.Move(this);			//慣性移動

	game.Draw(ctxBG2,GFXs["Sfx61"],	this.x,this.y,	0.6,0.6,
		false,Math.cos(this.Timer/3+index)*0.2,	false);

	//game.DrawSS(ctxBG2,GFXs["Sfx61"],	this.x,this.y,(this.Timer-1)*5,	0.6,0.6,
	//	false,Math.cos(this.Timer/3+index)*0.2,	false);

	game.GamenOut(this);	//画面外消失
}

//火の粒
//==============================================================================================
Game.prototype.HeatBeen = function(i) {
	this.Size = Math.random()/2 + 1;
}
Game.prototype.HeatBeen.prototype.Func = function(index) {
	if (this.Timer<500 && this.Size>0) {
		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//摩擦
		if (this.Size<0.8) this.hy+=0.05;
		game.Draw(ctxB,(this.Timer+index)%4<2 ? GFXs["Sfx28"] : GFXs["Sfx29"],	this.x,this.y,	this.Size,this.Size,	false,false,	false);
		this.Size -= 0.005;
		//game.GamenOut(this);	//画面外消失
	} else {
		this.Live = false;
	}
}
//爆発
//==============================================================================================
Game.prototype.Boom1 = function() {
}
Game.prototype.Boom1.prototype.Func = function(index) {
	const limit = 30;
	if (this.Timer<limit) {
		game.Move(this);			//慣性移動
		game.MoveLose(this,0.9);		//摩擦

		let gfxs = ["Sfx70","Sfx70","Sfx71","Sfx72","Sfx73","Sfx74","Sfx75","Sfx76"];
		const gam = limit / gfxs.length;
		const anime = Math.floor(this.Timer / gam);
		game.Draw(ctxB, GFXs[gfxs[anime]],	this.x,this.y,	1,1,	false,Math.random(),	["add"]);

	} else {
		this.Live = false;
	}
}


//大きめの爆発
//==============================================================================================
Game.prototype.Boom2 = function() {
}
Game.prototype.Boom2.prototype.Func = function(index) {
	const limit = 60;

	if (this.Timer<limit) {
		game.Move(this);			//慣性移動
		game.MoveLose(this,0.9);		//摩擦


		let gfxs = ["Sfx70","Sfx70","Sfx71","Sfx72","Sfx71","Sfx71","Sfx72","Sfx72","Sfx73","Sfx74","Sfx75","Sfx76"];
		const gam = limit / gfxs.length;
		const anime = Math.floor(this.Timer / gam);

		let size, t;
		const dsize = 1;

		gfxs = ["Sfx70","Sfx70","Sfx71","Sfx72","Sfx71","Sfx71","Sfx72","Sfx72","Sfx73","Sfx74","Sfx75","Sfx76"];
		size = this.Timer / limit * 300;
		t = this.Timer / 16;
		for(let i=0 ; i<TwoPI ; i+= TwoPI/6) 
			if(gfxs[anime] != 0) game.Draw(ctxB, GFXs[gfxs[anime]],	this.x+Math.cos(i+t) * size,this.y+Math.sin(i+t) * size,	dsize,dsize,	false,Math.random(),	["add"]);

		gfxs = ["Sfx70","Sfx70","Sfx71","Sfx72","Sfx71","Sfx71","Sfx72","Sfx73","Sfx74","Sfx75","Sfx76",0];
		size = this.Timer / limit * 200;
		t = -this.Timer / 16;
		for(let i=0 ; i<TwoPI ; i+= TwoPI/5) 
			if(gfxs[anime] != 0) game.Draw(ctxB, GFXs[gfxs[anime]],	this.x+Math.cos(i+t) * size,this.y+Math.sin(i+t) * size,	dsize,dsize,	false,Math.random(),	["add"]);

		gfxs = ["Sfx70","Sfx70","Sfx71","Sfx72","Sfx71","Sfx72","Sfx73","Sfx74","Sfx75","Sfx76",0,0];
		size = this.Timer / limit * 100;
		t = this.Timer / 16;
		for(let i=0 ; i<TwoPI ; i+= TwoPI/3) 
			if(gfxs[anime] != 0) game.Draw(ctxB, GFXs[gfxs[anime]],	this.x+Math.cos(i+t) * size,this.y+Math.sin(i+t) * size,	dsize,dsize,	false,Math.random(),	["add"]);

		//game.Draw(ctxB,(this.Timer+index)%2==0 ? GFXs["Sfx28"] : GFXs["Sfx29"],	this.x,this.y,	this.Size,this.Size,	false,false,	false);
		if (this.Timer<limit/2) {
			const r = Math.random()*TwoPI;
			const speed = Math.random()*20+20;
			game.SFXPush(this.x, this.y, Math.cos(r)*speed,Math.sin(r)*speed, 0,	new game.HeatBeen());
		}

	} else {
		this.Live = false;
	}
}
//黒煙
//==============================================================================================
Game.prototype.HeatSmoke1 = function() {
}
Game.prototype.HeatSmoke1.prototype.Func = function(index) {
	const limit = 50;
	if (this.Timer<limit) {
		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//摩擦
		//this.hy -= 0.1;

		let gfxs = ["Sfx80","Sfx81","Sfx82","Sfx83","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84"];
		const gam = limit / gfxs.length;
		const anime = Math.floor(this.Timer / gam);
		game.Draw(ctxB, GFXs[gfxs[anime]],	this.x,this.y,	1,1,	false,Math.random(),	[0,1-(this.Timer/limit)]);

	} else {
		this.Live = false;
	}
}

//黒煙を出すやつ
//==============================================================================================
Game.prototype.HeatSmoker = function() {
	this.Exist = true;

	this.mxs = [],	this.mys = [];
	this.mhxs = [],	this.mhys = [];
	this.mts = [];
}
Game.prototype.HeatSmoker.prototype.Func = function(index) {
	const limit = 180;
	const length = 50;

	if (this.Exist) {

		if (this.Timer<limit) {


			if (this.Timer%2==0) {
				//const r = Math.random()*TwoPI;
				//const speed = Math.random()*1;
				//game.SFXPush(this.x,this.y, Math.cos(r)*speed,Math.sin(r)*speed, 0,	new game.HeatSmoke1());
				this.mxs[0] = this.x;	this.mys[0] = this.y;
				this.mhxs[0] = Math.random()-0.5;	this.mhys[0] = Math.random()-0.5;

				this.mts[0] = true;
			}

			game.Move(this);			//慣性移動
			game.MoveLose(this,0.99);		//摩擦
			this.hy += 0.1;

			game.Draw(ctxA,(this.Timer+index)%4<2 ? GFXs["Sfx28"] : GFXs["Sfx29"],	this.x,this.y,	1,1,	false,false,	false);
		} else {
			this.Exist = false;
		}

	}


	if (!this.Exist && !this.mts[length]) {
			this.Live = false;

	} else {
			let gfxs = ["Sfx80","Sfx81","Sfx82","Sfx83","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84","Sfx84"];
			const gam = length / gfxs.length;
			for (let i=length-1 ; i>=0 ; i--) {

				if (this.mts[i]) {

					this.mxs[i] += this.mhxs[i];
					this.mys[i] += this.mhys[i];

					this.mxs[i+1] = this.mxs[i];
					this.mys[i+1] = this.mys[i];

					this.mhxs[i+1] = this.mhxs[i];
					this.mhys[i+1] = this.mhys[i];

					this.mts[i+1] = this.mts[i];

					const anime = Math.floor(i / gam);
					game.Draw(ctxB, GFXs[gfxs[anime]],	this.mxs[i],this.mys[i],	0.5,0.5,	false,Math.random(),	[0,1-(i/length)]);
					this.mts[i] = false;
				}


			}

	}

}
//閃光
//==============================================================================================
Game.prototype.Pika = function() {
}
Game.prototype.Pika.prototype.Func = function(index) {
	const limit = 3;
	if (this.Timer<limit) {
		if(Loop2) game.Draw(ctxUI, GFXs["Sfx27"],	this.x,this.y,	1,1,	false,this.Timer/12+index,	false);
	} else {
		this.Live = false;
	}
}

//落ちたボム肥満化ボンベ
//==============================================================================================
Game.prototype.FallingFatTank = function(i) {
	this.Roll = 0;
}
Game.prototype.FallingFatTank.prototype.Func = function(index) {

	if (this.Timer<500) {

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//摩擦
		this.hy += 0.5;
		this.Roll += 0.08;

		const speed = 20 + game.Random(5);
		for (let i=0 ; i<5 ; i++) {
			game.SFXPush(this.x + Math.cos(this.Roll)*100, this.y + Math.sin(this.Roll)*100,
				Math.cos(this.Roll)*speed + game.Random(3), Math.sin(this.Roll)*speed + game.Random(3),	this.Roll,	new game.FatSlag());
		}

		game.Draw(ctxA,GFXs["Player16"],	this.x,this.y,	1,1,	false,this.Roll,	false);

		game.GamenOut(this);	//画面外消失

	} else {
		this.Live = false;
	}
}

//衝撃波
//==============================================================================================
Game.prototype.AirRing = function(size = 1) {
	this.Size  = size * 0.5;
	this.DSize = 0;
}
Game.prototype.AirRing.prototype.Func = function(index) {
	const limit = 20;
	if (this.Timer<limit) {
		this.DSize = game.Name2(this.DSize, this.Size, 0.2);
		game.Draw(ctxB, GFXs["Sfx05"],	this.x,this.y,	this.DSize,this.DSize,	false,false,	[false,1-(this.Timer/limit)]);
	} else {
		this.Live = false;
	}
}

//==============================================================================================
//==============================================================================================
//その他スプライト
//==============================================================================================
//==============================================================================================

//ボスの爆発
//==============================================================================================
Game.prototype.BigBoom = function(s) {
	this.Length = s;
}
Game.prototype.BigBoom.prototype.Func = function(index) {
	const t = this.Timer;
	if (t < 500) {
		if (t<200) {
			if (t%10 == 0) {
				game.FatSlagsFunc(this.x+game.Random(this.Length),this.y+game.Random(this.Length),10);
			}
			if (t%80 == 0) game.SFXPush(this.x+game.Random(this.Length),this.y+game.Random(this.Length), 0,0, 0,	new game.Stars());
		} else {
			if (t<400) {
				Blacking = Math.min(1,Blacking+0.01);
				for (let i=0 ; i<3 ; i++) {
					const r = Math.random()*TwoPI;
					const s = Math.random()*20+20;
					game.SFXPush(this.x,this.y,	Math.cos(r)*s,Math.sin(r)*s,	r, new game.FatSlag2());
				}
			} else {
				Blacking = 0;
			}
			const size = Math.sin(((t-200)/300*PI))*10;
			const r = Math.random();
			game.Draw(ctxBG2,GFXs["Sfx22"],	this.x,this.y,	size,size,	false,r,	false);
			game.Draw(ctxUI,GFXs["Sfx22"],	this.x,this.y,	size,size,	false,r,	[0,(t-200)/200]);
		}
	} else {
		this.Live = false;
				for (let i=0 ; i<10 ; i++) {
					const r = Math.random()*TwoPI;
					const s = Math.random()*20+5;
					game.SFXPush(this.x,this.y,	Math.cos(r)*s,Math.sin(r)*s,	r, new game.FatSlag2());
				}
	}
}

//照明
//==============================================================================================
Game.prototype.Denki = function(s) {
	this.gx = 1500,	this.gy = -200;
	this.Size = [50,50];

	this.Roll = 0,	this.RollPls = 0;
}
Game.prototype.Denki.prototype.Func = function(index) {
	//スクロールアウト
	if (this.gx<-2000) {
		this.Live = false;
	} else {

		//スクロール
		this.x += LevelSpeedHX;
		this.gx += LevelSpeedHX;

		//揺れ
		this.hx -= (this.x - this.gx) * 0.01;
		this.hy -= (this.y - this.gy) * 0.01;
		this.hy += 0.03;

		this.RollPls *= 0.99;
		this.Roll += this.RollPls;

		this.hy += Math.cos(this.Timer/10)*0.06;

		//当たって揺れる
		if (game.Atari(this.x, this.y, this.Size,	Player.x, Player.y, Player.Size2)) {
			const rs = game.PlayerRadis(this.x,this.y);
			this.hx = rs[0]*-8;
			this.hy = rs[1]*-8;

			/*const r = game.PlayerRadi(this.x,this.y);
			this.x = Player.x + Math.cos(r) * -Player.Size2[0]-6;
			this.y = Player.y + Math.sin(r) * -Player.Size2[1]-6;*/

			this.RollPls += Player.x < this.x ? 0.005 : -0.005;
		}

		//game.MoveLose(this,0.98);		//摩擦
		this.hx *= 0.95;
		this.hy *= 0.98;
		game.Move(this);			//慣性移動

		//コード
		const can = ctxB;
		can.strokeStyle = "black";
		can.lineWidth = 5;
		game.DrawLine(can, this.gx-800, this.gy-500,	this.x, this.y);
		game.DrawLine(can, this.gx+800, this.gy-500,	this.x, this.y);
		can.strokeStyle = "#AAA";
		can.lineWidth = 3;
		game.DrawLine(can, this.gx-800, this.gy-500,	this.x, this.y);
		game.DrawLine(can, this.gx+800, this.gy-500,	this.x, this.y);


		//描画
		game.Draw(ctxB,GFXs["BG40"],	this.x,this.y,	1,1,	false,this.Roll,	false);
		//game.Draw(ctxB,GFXs["Test"],	this.x,this.y,	1,1,	false,false,	false);

		//レンズフレア

		const sx = this.x + Math.cos(this.Roll-3.9) * 40;	//開始位置
		const sy = this.y + Math.sin(this.Roll-3.9) * 40;
		//game.Draw(ctxB,GFXs["Test"],	sx,sy,	1,1,	false,false,	false);
		game.Draw(ctxA,GFXs["Sfx24"],	sx,sy,	1,1,	false,false,	["add"]);

		if (Math.abs(this.x) < WidthHalf+100) {

			const lr = game.Radi(sx,sy,0,ScreenY);			//角度
			const lc = Math.cos(lr),	ls = Math.sin(lr);

			const ll = game.Length(sx,sy,0,ScreenY);	//距離

			for (let i=0 ; i<8 ; i++) {
				const pls = (i*i)/20;
				let s = pls * 0.5;
				let xx = sx + (ll/12 * lc*i)*pls;
				let yy = sy + (ll/12 * ls*i)*pls;
				const a = 1-(i/8) * (Loop2 ? 0.8 : 1);
				game.Draw(ctxUI,GFXs["Sfx26"],	xx,yy,	s,s,	false,false,	[false,a]);

				s = Math.abs(8-i) * 0.01;
				xx = sx + (ll/8 * lc*i)*pls;
				yy = sy + (ll/8 * ls*i)*pls;
				game.Draw(ctxUI,GFXs["Sfx25"],	xx,yy,	s,s,	false,false,	[false,a]);

			}
		}

	}
}

//落ちたキノダガード
//==============================================================================================
Game.prototype.FatGuard = function(s) {
	this.FallTimer = 0;
	this.Fall = false;
	this.Size = 1;
	this.Roll = 0;
	this.RollPls = 0;
}
Game.prototype.FatGuard.prototype.Func = function(index) {
	const t = this.Timer;


	if (this.Timer<2000) {

		let img = "Teki73"

		if (this.Fall) {
			const tt = this.FallTimer;
			if(tt<100) {
				img = t%10<5 ? "Teki75" : "Teki74";

			} else if (tt<200) {
				if (tt==100) this.Size = 0.6;
				img = t%10<5 ? "Teki76" : "Teki77";

			} else if (tt<400) {
				if (tt==200) this.Size = 0.6;
				img = "Teki78";
				this.RollPls -= (this.Roll-HalfPI)/2000;
			} else {
				if (tt==400) this.Size = 0.6;
				img = "Teki79";
				//this.Roll = Math.min(HalfPI, this.Roll+0.002);
				this.RollPls -= (this.Roll-HalfPI)/1000;
				this.y += 0.1;
				this.Size = Math.min(2, this.Size+0.0006);
			}

			this.Roll += this.RollPls;
			this.RollPls *= 0.99;
			this.x -= 1.5;
			this.FallTimer++;

		if(this.Size<1) this.Size = game.Name2(this.Size, 1, 0.1);
		game.Draw(ctxB,GFXs[img],	this.x,this.y+Math.cos(t/20)*20,	this.Size + Math.cos(t/4)/30,this.Size + Math.sin(t/5)/30,	false,this.Roll,	false);

		//落下
		} else {
			this.hy += 0.2;
			game.Move(this);				//慣性移動
			game.MoveLose(this,0.98);		//摩擦

			if (this.y>300) {
				this.Fall = true;
				this.Size = 0.5;
				game.PlaySE("Splash00");
			}
			game.Draw(ctxA,GFXs["Teki73"],	this.x+Math.cos(t)*2,this.y,	this.Size,this.Size,	false,this.Roll,	false);
		}

		game.AseFunc(this.x+60, this.y-100);

	} else {
		this.Live = false;
	}

}

//==============================================================================================
//==============================================================================================
//弾丸スプライト
//==============================================================================================
//==============================================================================================

//呪われたチーズ（1万カロリー）
//==============================================================================================
Game.prototype.TizuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.TizuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	for (let h=4 ; h>=0 ; h--) {
		size = 1-h/6;
		game.Draw(ctxB,GFXs["Tama20"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	game.Draw(ctxA,GFXs["Tama10"],	this.x,this.y,	1,1,	false,-this.Timer/12+index,	false);
}


//違法ナゲット（２万カロリー）
//==============================================================================================
Game.prototype.NikuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.NikuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama15"],	this.x,this.y,	1,1,	false,false,		false);
		game.Draw(ctxB,GFXs["Tama23"],	this.x,this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//悪魔の人参（0.7万カロリー）
//==============================================================================================
Game.prototype.NInzinShoot = function() {
	this.Size = [20,20];
}
Game.prototype.NInzinShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	for (let h=4 ; h>=0 ; h--) {
		size = 1-h/6;
		game.Draw(ctxB,GFXs["Tama21"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}

	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	game.Draw(ctxA,GFXs["Tama12"],	this.x,this.y,	1,1,	false,this.Radi,	false);
}

//トゲ
//==============================================================================================
Game.prototype.HariShoot = function() {
	this.Size = [10,10];
}
Game.prototype.HariShoot.prototype.Func = function(index) {
	if (this.Timer < 20) {

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//慣性移動

		game.Draw(ctxB,GFXs["Tama21"],
			this.x,this.y, 0.7,0.7,	false,Math.random(),	["add"]);
		game.Draw(ctxA,GFXs["Tama11"],	this.x,this.y,	1,1,	false,false,	false);

		//当たり
		if (game.PlayerHit(this)) {
			this.Live = false;
			game.PlayerKill(2);
		}
	} else {
		this.Live = false;
	}
}

//デスお稲荷（１万カロリー）
//==============================================================================================
Game.prototype.OinariShoot = function() {
	this.Size = [30,30];
}
Game.prototype.OinariShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {
		//減加速
		if (this.Timer<50) {
			game.MoveLose(this,0.98);		//摩擦
			//this.Radi = game.PlayerRadi(this.x, this.y);
		} else if (this.Timer<80) {
			this.hx += Math.cos(this.Radi) *Rank / 5;
			this.hy += Math.sin(this.Radi) *Rank / 5;
		}

		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama17"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		for (let h=4 ; h>=0 ; h--) {
			size = (1-h/6);
			game.Draw(ctxB,GFXs["Tama21"],
				this.x-this.hx*h*2, this.y-this.hy*h*2,
				size,size,	false,Math.random(),	["add"]);
		}
	}
}

//魔改造フランスパン（2万カロリー）
//==============================================================================================
Game.prototype.FuramsuShoot = function() {
	this.Size = [10,10];
}
Game.prototype.FuramsuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {

		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama18"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		for (let h=4 ; h>=0 ; h--) {
			size = (1-h/6)*1.5;
			game.Draw(ctxB,GFXs["Tama24"],
				this.x-this.hx*h*4, this.y-this.hy*h*4,
				size,size,	false,Math.random(),	["add"]);
		}
	}
}

//カロリーナッツ（５千カロリー）
//==============================================================================================
Game.prototype.NattuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.NattuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	if (this.Timer < 60) {
		const s = this.Timer / 6 * Rank;
		this.hx = Math.cos(this.Radi)*s;
		this.hy = Math.sin(this.Radi)*s;
	}

	for (let h=4 ; h>=0 ; h--) {
		size = (1-h/6)*0.8;
		game.Draw(ctxB,GFXs["Tama21"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	game.Draw(ctxA,GFXs["Tama31"],	this.x,this.y,	1,1,	false,this.Radi,	false);
}

//デブハム（５兆カロリー）
//==============================================================================================
Game.prototype.HamuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.HamuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	const s = Math.cos(Loop/2+index)/8+1;
	game.Draw(ctxA,GFXs["Tama32"],	this.x,this.y,	s,s,	false,this.Radi+0.3,	false);
	game.Draw(ctxB,GFXs["Tama20"],	this.x,this.y,	1.1,1.1,	false,Math.random(),	["add"]);
}

//肥満化クッキー
//==============================================================================================
Game.prototype.MateShoot = function() {
	this.Size = [20,20];
}
Game.prototype.MateShoot.prototype.Func = function(index) {
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.9);		//摩擦
		const tt = Math.min(20, this.Timer/6);
		this.x += Math.cos(this.Radi) *tt;
		this.y += Math.sin(this.Radi) *tt;
		game.GamenOut(this);		//画面外消失

		game.Draw(ctxA,GFXs["Tama34"],	this.x,this.y,	1,1,	false,this.Radi,		false);

		for (let h=4 ; h>=0 ; h--) {
			size = (1-h/6)*1.5;
			game.Draw(ctxB,GFXs["Tama24"],
				this.x-this.hx*h*2, this.y-this.hy*h*2,
				size,size,	false,Math.random(),	["add"]);
		}
	}
}

//フェザーカッター
//==============================================================================================
Game.prototype.HaneShoot = function() {
	this.Size = [30,30];
}
Game.prototype.HaneShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(1);
	} else {
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama30"],	this.x,this.y,	1,1,		false,this.Radi,		false);
		game.Draw(ctxB,GFXs["Tama21"],	this.x, this.y,	1.5,1.5,	false,Math.random(),	["add"]);
	}
}

//羽馬の蹄鉄
//==============================================================================================
Game.prototype.TeiShoot = function() {
	this.Size = [20,20];
}
Game.prototype.TeiShoot.prototype.Func = function(index) {
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(2);
	} else {
		game.Move(this);			//慣性移動
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama19"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		game.Draw(ctxB,GFXs["Tama20"],	this.x, this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//デスアックス
//==============================================================================================
Game.prototype.OnoShoot = function(ty,s,r=0) {
	this.Size = [50*s,50*s];
	this.Deka = s;
	this.Type = ty;
	this.kx = 0;	this.ky = 0;
	this.ShootR = r;
}
Game.prototype.OnoShoot.prototype.Func = function(index) {
	const t = this.Timer;
	game.GamenOut(this);		//画面外消失
	game.Move(this);			//慣性移動
	switch (this.Type) {
		case 1 :
			this.hy *= 0.95;
			this.hx -= 0.2;
			break;
		case 2:
			if (this.Timer<15) {
				game.MoveLose(this,0.97);
			} else if (this.Timer<30) {
				this.ShootR = game.PlayerRadi(this.x, this.y);
				this.hx += Math.cos(this.ShootR) * Rank;
				this.hy += Math.sin(this.ShootR) * Rank;
			}
			break;
		case 3:
			if (t==0) {
				this.kx = -this.hx;
				this.ky = -this.hy;
			} else if (t<15) {
				game.MoveLose(this,0.97);
			} else if (t<45) {
				this.hx += this.kx*0.002 * Rank/2;
				this.hy += this.ky*0.002 * Rank/2;
			}
			break;

		case 4:
			if (this.Timer<15) {
				game.MoveLose(this,0.95);
			} else {
				if (this.Timer>20) this.hy += (this.y<Player.y ? 0.1 : -0.1) * Rank;
				this.hx -= 0.3;
			}
			break;
	}

	for (let h=4 ; h>=0 ; h--) {
		size = (1-h/4)*2;
		game.Draw(ctxB,GFXs["Tama22"],
			//this.x-(Math.cos(this.Radi)*h*40),this.y-(Math.sin(this.Radi)*h*40),
			this.x-this.hx*h*2, this.y-this.hy*h*2,
			size,size,	false,Math.random(),	["add"]);
	}

	//当たり
	if (game.PlayerHit(this)) {
		//this.Live = false;
		game.PlayerKill(1);
	}

	game.Draw(ctxA,GFXs["Tama13"],	this.x,this.y,	1,1,	false,-this.Timer/6+index,	false);
}

//謎肉ソーセージ（１万カロリー）
//==============================================================================================
Game.prototype.SoseziShoot = function(t) {
	this.Size = [30,30];
	this.Type = t;
}
Game.prototype.SoseziShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	let img = "Tama24";
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {
		switch (this.Type) {
			case 0:
				break;
			//減加速
			case 1:
				img = "Tama20";
				if (this.Timer<50) {
					game.MoveLose(this,0.98);		//摩擦
					//this.Radi = game.PlayerRadi(this.x, this.y);
				} else {
					this.hx += Math.cos(this.Radi) *Rank / 4;
					this.hy += Math.sin(this.Radi) *Rank / 4;
				}
				break;
			//置いてく
			case 2:
				img = "Tama21";
				if (this.Timer>2 && this.Timer%4==0 && this.x>-500) {
					game.TekiTamaPush(this.x, this.y,	0,0, 0,		new game.SoseziShoot(3));
				}
				this.hy *= 0.98;
				break;
			//向かって加速
			case 3:
				img = "Tama20";
				if (this.Timer<100) {
					if (game.LiveShoot()) this.Radi = game.PlayerRadi(this.x, this.y)+PI;
				} else {
					this.hx += Math.cos(this.Radi) *Rank / 8;
					this.hy += Math.sin(this.Radi) *Rank / 8;
				}
				break;
			case 10:
				//Math.min(-HalfPI,this.Radi-0.1);
				this.Radi -= this.hx/50;
				this.hx *= 0.995;
				this.hy += (Rank)*0.1;
				this.hy *= 0.98;
				break;
		}
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama16"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		game.Draw(ctxB,GFXs[img],	this.x,this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//致死ししとう
//==============================================================================================
Game.prototype.TougarasiShoot = function() {
	this.Size = [10,10];
}
Game.prototype.TougarasiShoot.prototype.Func = function(index) {

	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(1);
	} else {
		game.Move(this, Math.min(13, this.Timer/2-5));			//慣性移動
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama35"],	this.x,this.y,	1,1,		false,this.Radi,		false);
		game.Draw(ctxB,GFXs["Tama20"],	this.x, this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//炎
//==============================================================================================
Game.prototype.FireShoot = function(gx,gy) {
	this.Size = [30,30];
	//this.gx = Math.max(-SizeX,Math.min(SizeX,gx)),	this.gy = Math.max(-SizeY,Math.min(SizeY,gy));
	this.gx = gx,	this.gy = gy;
}
Game.prototype.FireShoot.prototype.Func = function(index) {

	const limit = 60 - 10*Rank;
	const r = game.PlayerRadi(this.x, this.y);
	if(this.Timer >= limit) {
		//game.PlaySE("Shoot02");		//音
		game.TekiTamaPush(this.x, this.y,	Math.cos(r),Math.sin(r), r,		new game.TougarasiShoot());
		//game.SFXPush(this.x, this.y, game.Random(10),game.Random(10), 0,	new game.Boom1());
		this.Live = false;
	}

	this.gx -= 1;

	this.x = game.Name2(this.x,this.gx,0.05);
	this.y = game.Name2(this.y,this.gy,0.05);


	const imgs = ["Tama40","Tama41","Tama42","Tama43"];
	const anime = Math.floor((this.Timer+index)/3)%imgs.length;
	const siz = Math.min(1.5,this.Timer*0.1);
	game.Draw(ctxB,GFXs[imgs[anime]],	this.x, this.y,	siz,siz,	false,false,	false);

	game.Draw(ctxA,GFXs["Tama35"],	this.x,this.y,	0.3,0.3,		false,r,		false);
}

//殺戮貝殻
//==============================================================================================
Game.prototype.KaiShoot = function() {
	this.Size = [30,30];
}
Game.prototype.KaiShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this,10);		//画面外消失
	this.hy += 0.1;
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}

	game.Draw(ctxA,GFXs["Tama36"],	this.x,this.y,	1,1,	false,this.Timer/3+index,	false);
	game.Draw(ctxB,GFXs["Tama21"],	this.x, this.y,	1,1,	false,Math.random(),	["add"]);
}

//自機の脂肪弾
//==============================================================================================
Game.prototype.ZikiFatShoot = function(p,h) {
	this.Size = [40,10];
	this.Pow = p;
	this.Height = h;
}
Game.prototype.ZikiFatShoot.prototype.Func = function(index) {

	const atari = game.Ataris(this);

	//if(this.Timer<3) this.Pow-=0.2;

	//着弾
	if (atari != null) {
		this.Live = false;
		Sprites[atari].Debu += this.Pow;
		Sprites[atari].Dame	 =  true;
		Sprites[atari].DameTimer = 0;

		game.PlaySE("Hit00",1,0.5 + Math.random()*1.5,1);
		game.ScoreMan(1);		//スコア

		//for (var i=0 ; i<2 ; i++ ) {
			const rad = game.Random(1);
			const speed = Math.random()*5+5;
			game.SFXPush(this.x, this.y,	Math.cos(rad)*speed, Math.sin(rad)*speed,	rad,	new game.FatSlag());
		//}

	}

	game.Move(this);		//慣性移動
	game.GamenOut(this);	//画面外消失
	//描画
	game.Draw(ctxA,GFXs["Tama00"],	this.x,this.y,	1,this.Height,	false,this.Radi,	false);
}
//自機の肥満化チューブ
//==============================================================================================
Game.prototype.ZikiFatTube = function(ind,ky,pi=PI) {
	this.Size = [50,50];
	this.LockIndex = ind;	this.LockKey = ky;

	this.Drive = false;
	this.DriveTimer = 0;

	this.DeathTimer = 0;

	this.Radis = [pi];
	this.RadiExists = [true];

	//this.TubeXs = [];
	//this.TubeYs = [];
}
Game.prototype.ZikiFatTube.prototype.Func = function(index) {

	const t = this.Timer;

	Bombing = true;

	//消滅
	if (!game.LiveShoot()) {
		this.Live = false;

	} else {

		if (Sprites[this.LockIndex] != null && Sprites[this.LockIndex].Key == this.LockKey && t<500) {
			const sp = Sprites[this.LockIndex];
			const kx = sp.x+sp.Kutix;	const ky = sp.y+sp.Kutiy;

			//追いかけ
			if(!this.Drive) {
				if (t<30) {
					game.MoveLose(this,0.85);		//摩擦
					this.hx -= 0.5;
				} else {
					const radi = game.Radi(this.x, this.y,	kx, ky);
					const speed = t;
					this.hx = game.Name2(this.hx, Math.cos(radi)*speed, 0.5);
					this.hy = game.Name2(this.hy, Math.sin(radi)*speed, 0.5);
					//const got = (t-30)*0.02;
					//this.x = game.Name2(this.x, kx, got);
					//this.y = game.Name2(this.y, ky, got);
				}

				game.Move(this);			//慣性移動
				//this.Radis[0] = PI;
				//到達
				if (Math.abs(this.x-kx)<this.Size[0] ? (Math.abs(this.y-ky)<this.Size[1]) : false) {
					this.Drive = true;
					game.PlaySE("Boom01");
					game.SFXPush(kx, ky, 0,0, 0,	new game.Stars());

				}

				//this.TubeXs.push(this.x);
				//this.TubeYs.push(this.y);

			//注入
			} else {
				this.x = kx + Math.sin(Loop+index)*5;	this.y = ky;
				this.Radis[0] = PI + Math.sin(t/8+index);		//根元が勝手にぐにょぐにょ曲がる
				this.DriveTimer++;
				if (t%15==0) {
					sp.Debu += 40;
					sp.Dame	 =  true;
					sp.DameTimer = 0;
					//sp.y += 0.5;
					//game.PlaySE("Shoot00");

					const rad = Math.random()*TwoPI;
					const speed = Math.random()*10+4;
					game.SFXPush(this.x, this.y,	Math.cos(rad)*speed, Math.sin(rad)*speed,	rad,	new game.FatSlag());
				}
				//if (t%3==0) game.PlaySE("Shoot00");

				game.ScoreMan(1);		//スコア
			}

				//game.Draw(ctxUI,GFXs["Sfx23"],	this.x,this.y,	1,1,	false,false,	false);

		//終わって暴れる
		} else {
			this.DeathTimer++;
			this.Radis[0] = PI + Math.sin(t/6+index)/2;		//根元が勝手にぐにょぐにょ曲がる

			const rad = Math.random()*0.1 + this.Radis[0]+PI;
			const speed = Math.random()*10+4;
			game.SFXPush(this.x, this.y,	Math.cos(rad)*speed, Math.sin(rad)*speed,	rad,	new game.FatSlag());

			this.hy += Math.sin(this.Radis[0])*5;
			game.Move(this);			//慣性移動
			game.MoveLose(this,0.8);		//摩擦

			this.x = game.Name2(this.x, Player.x, 0.04);
			this.y = game.Name2(this.y, Player.y, 0.04);

			if ((Math.abs(Player.x-this.x)<200 ? (Math.abs(Player.y-this.y)<200) : false) || this.DeathTimer >= 200) {
				this.Live = false;
			}
		}

		//チューブの処理
		/*this.TubeXs[0] = Player.x;
		this.TubeYs[0] = Player.y;
		this.TubeXs[this.TubeXs.length-1] = this.x;
		this.TubeYs[this.TubeXs.length-1] = this.y;
		for (let i=1 ; i<this.TubeXs.length-2 ; i++) {

				let tawa = Math.abs((i/this.TubeXs.length/2)-0.5);
				this.TubeXs[i] = game.Name2(this.TubeXs[i], this.TubeXs[i-1], tawa);
				this.TubeYs[i] = game.Name2(this.TubeYs[i], this.TubeYs[i-1], tawa);
				tawa = 1-tawa;
				this.TubeXs[i] = game.Name2(this.TubeXs[i], this.TubeXs[i+1], tawa);
				this.TubeYs[i] = game.Name2(this.TubeYs[i], this.TubeYs[i+1], tawa);

			game.Draw(ctxUI,GFXs["Tama31"],	this.TubeXs[i],this.TubeYs[i],	0.5,0.5,	false,false,	false);
		}*/

		let goingx = this.x;		//関節を伸ばすのに使う座標	
		let goingy = this.y;

		//this.Radis[0] = PI + Math.sin(t/10+index);		//根元が勝手にぐにょぐにょ曲がる

		//this.Radis[0] =game.Name2(this.Radis[0],0,0.1);
		//if(game.UP(true)) 	this.Radis[0]+= 0.2;		//プレーヤの操作で若干曲がる？
		//if(game.DOWN(true))	this.Radis[0]-= 0.2;

		//this.Radis[0] += TwoPI;
		//this.Radis[0] = this.Radis[0]%TwoPI

		// =game.Name2(this.Radis[0]+PI, game.Radi(Player.x+10 ,Player.y,	this.x, this.y)+PI,0.1)-PI;

		let flamelength = 0;

		for (let i=1 ; i<200 ; i++) {

			let gr = game.Radi(goingx ,goingy,	Player.x, Player.y);	//自キャラへの方向

			if (gr>PI) gr -= TwoPI;

			if (this.RadiExists[i] != true) {
				this.Radis[i] = gr;
				this.RadiExists[i] = true;
			}

			const leng = Math.min(t/2+10,40);				//関節間の長さ
			//const leng = Math.min(40,Math.max(10, game.Length(this.x ,this.y,	Player.x, Player.y)/20));				//関節間の長さ

			goingx += Math.cos(this.Radis[i])*leng;		//関節を伸ばす
			goingy += Math.sin(this.Radis[i])*leng;


			//曲がる処理
			//const len2 = (goingx-Player.x)*(goingx-Player.x) + (goingy-Player.y)*(goingy-Player.y);
			//this.Radis[i] = (this.Radis[i]+TwoPI+TwoPI)%TwoPI;
			//this.Radis[i] = game.Name2(this.Radis[i]+PI,	(game.Name2( this.Radis[i-1]+PI , gr+PI ,0.01)-PI)+PI	, 0.5)-PI;


			if (this.Radis[i]-gr > PI) gr += TwoPI;
			if (this.Radis[i]-gr < -PI) gr -= TwoPI;


			this.Radis[i] = game.Name2(this.Radis[i]+TwoPI,		gr+TwoPI,					Math.min(20,i)*0.03)	- TwoPI;		//今の角度と自キャラへの角度をより合わせる
			this.Radis[i] = game.Name2(this.Radis[i]+TwoPI,		this.Radis[i-1]+TwoPI,		0.5)	- TwoPI;		//今の角度と一個前の節の角度をより合わせる

			//this.Radis[i] = game.Name2(this.Radis[i], gr, (i*0.01));
			//this.Radis[i] = game.Name2(this.Radis[i], this.Radis[i-1], 0.5);

			//描画
			const big = Math.ceil(this.DriveTimer+i)%15 == 0 && i>50-this.DriveTimer;		//モコッとしてるところ
			const size = big ? 1.4 : 0.5;							//モコッとしてるところだったらでっかっく描く
			//const size = (Math.max(0,Math.sin(this.DriveTimer/1.5 + i/2)-0.7)*1.8)*Math.min(1,this.DriveTimer/20)+0.5;	
			game.Draw(ctxA,GFXs["Tama02"],	goingx,goingy,	size,size,	false,this.Radis[i],	false);

			//const len = (goingx-this.x)*(goingx-this.x) + (goingy-this.y)*(goingy-this.y);
			if ((Math.abs(goingx-Player.x)<100 ? (Math.abs(goingy-Player.y)<100) : false)) {

				while (this.RadiExists[i] != false){
					i++;
					this.RadiExists[i] = false;

				}
				break;
			}
			//flamelength = len;
		}
		game.Draw(ctxA,GFXs["Tama03"],	this.x,this.y,	1,1,	false,false,	false);

	}
}
//==============================================================================================
//==============================================================================================
//アイテムスプライト
//==============================================================================================
//==============================================================================================

//ビット柴
//==============================================================================================
Game.prototype.BitSiba = function() {
	this.Size = [60,80];
}
Game.prototype.BitSiba.prototype.Func = function(index) {
	if (this.Timer<300) {
		if (this.x>200) this.x -= 2;
	} else if (this.Timer<400) {
	} else {
		game.GamenOut(this);	//画面外消失
		this.x -= 5;
	}

	//当たり
	if (game.Atari2(Player,this) && Player.Live) {
		if (Player.Sibas.length<2) {
			game.GetSiba();
		} else {
			game.ScoreMan(800);		//スコア
		}
			this.Live = false;
	}

	game.DrawKage(ctxA,GFXs[Loop8 ? "Player22" : "Player23"],	this.x,this.y,
		0.7+Math.cos(this.Timer/6)/10,0.7-Math.cos(this.Timer/6)/10,	false,-this.Timer/32+index,	false);

	game.Draw(ctxA,GFXs["Text30"],	this.x,this.y+40,	1,1,	false,false,	false);
}

//アイテム肉
//==============================================================================================
Game.prototype.NikuNiku = function() {
	this.Size = [60,60];
	this.Tobi = false;
}
Game.prototype.NikuNiku.prototype.Func = function(index) {
	if (this.Tobi) {
		const r = game.PlayerRadis(this.x, this.y);
		this.x += r[0] * this.Timer;
		this.y += r[1] * this.Timer;
	} else {
		if (!game.SHOOT(true) && game.LiveShoot()) {
			this.Tobi = true;
			this.Timer = 0;
		}
		this.hy += 0.1;
		game.MoveLose(this,0.98);	//摩擦
		if (this.Timer>200) game.GamenOut(this);	//画面外消失
	}
	game.Move(this);			//慣性移動

	//当たり
	if (game.Atari2(Player,this)) {
		game.ScoreMan(100);		//スコア
		if (Player.DrawSize>0.9) Player.DrawSize -= 0.01;
		this.Live = false;
		game.PlaySE("Get01", 1, 1.2+(Math.random()-0.5)*0.4);
	}

	const size = (Math.random()*2+6)*0.1;
	game.Draw(ctxA,GFXs["Tama01"],	this.x,this.y,	size,size,	false,false,	false);
}


//==============================================================================================
//==============================================================================================
//コマンドスプライト
//==============================================================================================
//==============================================================================================

//開始文字
//==============================================================================================
Game.prototype.StartTextMan = function(img) {
	this.Img = img;
}
Game.prototype.StartTextMan.prototype.Func = function(index) {
	if (this.Timer < 300) {
		if (this.Timer<200) {

			ctxUI.fillStyle = "black";
			ctxUI.globalAlpha = Math.min(0.5, this.Timer/50);
			game.FillCan(ctxUI);
			ctxUI.globalAlpha = 1;

			ctxUI.save();
			ctxUI.beginPath();
			ctxUI.rect(-WidthHalf, -HeightHalf, Width, this.Timer*10);
			ctxUI.clip();
			game.Draw(ctxUI,GFXs[this.Img],	0,ScreenY,	1,1,	false,false,	false);
			ctxUI.restore();
			
		} else {
			if (Loop%20<15) game.Draw(ctxUI,GFXs["Text20"],	0+game.Random(2),ScreenY+game.Random(2),	1,1,	false,false,	false);
			ctxUI.fillStyle = "black";
			ctxUI.globalAlpha = 0.5-Math.min(0.5, (this.Timer-200)/50);
			game.FillCan(ctxUI);
			ctxUI.globalAlpha = 1;
		}
	} else {
		this.Live = false;
	}
}

//文字
//==============================================================================================
Game.prototype.BossTextMan = function() {
}
Game.prototype.BossTextMan.prototype.Func = function(index) {

	if (this.Timer < 200) {
			ctxUI.globalAlpha = 0.8;
			const size = Math.sin((this.Timer/20)/PI)*40;

			ctxUI.beginPath();
			ctxUI.save();
			ctxUI.rect(-WidthHalf,-HeightHalf,WidthHalf,Height);
			ctxUI.clip();
			for (var i=-1 ; i<1 ; i++) {
				const offx = (-Loop*20)%600 + i*600;
				ctxUI.drawImage(GFXs["Text23"],	offx,-size,	600,size*2);
			}
			ctxUI.restore();
			ctxUI.save();
			ctxUI.beginPath();
			ctxUI.rect(0,-HeightHalf,WidthHalf,Height);
			ctxUI.clip();
			for (var i=-1 ; i<1 ; i++) {
				const offx = (Loop*20)%600 + i*600;
				ctxUI.drawImage(GFXs["Text22"],	offx,-size,	600,size*2);
			}
			ctxUI.restore();
			ctxUI.globalAlpha = 1;

		if (this.Timer>50) {
			if (Loop%20<15) game.Draw(ctxUI,GFXs["Text21"],	0+game.Random(2),ScreenY+game.Random(2),	1,1,	false,false,	false);
		}
	} else {
		this.Live = false;
	}
}
//LEVEL終了
//==============================================================================================
Game.prototype.EndTextMan = function(t,l) {
	this.Type = t;
	this.Level = l;
}
Game.prototype.EndTextMan.prototype.Func = function(index) {
	const t = this.Timer;

	if (t<200) {
		BlackFlag = true;
	}
	if (t==200) {
		//game.WallCall();
		switch (this.Type) {
			case 0:
				game.LevelPush(this.Level);
				this.Live = false;

				break;
		}
	}
}
//==============================================================================================
//==============================================================================================
//==============================================================================================